#ifndef _JZ_P32MX_BLCFG_H_
#define _JZ_P32MX_BLCFG_H_
#include <stdint.h>

#define _APP_FLASH_START   0xBD000000
#define _BOOT_FLASH_START  0xBFC00000

#if defined(__32MX1XX__) || defined(__32MX2XX__)
  #define _BOOT_FLASH_END  0xBFC00BFF
#else // elif defined(__32MX3XX__) || defined(__32MX4XX__)
  #define _BOOT_FLASH_END  0xBFC02FFF
#endif

#if defined(__32MX1XX__) || defined(__32MX2XX__)
  #define _BLCFG3         ((struct blcfg3 *)0xBFC00BE0)
  #define BLCFG3          (*(unsigned *)0xBFC00BE0)
  #define BLCFG2          (*(unsigned *)0xBFC00BE4)
  #define BLCFG1          (*(unsigned *)0xBFC00BE8)
  #define BLCFG0          (*(unsigned *)0xBFC00BEC)
#else // elif defined(__32MX3XX__) || defined(__32MX4XX__)
  #define _BLCFG3         ((struct blcfg3 *)0xBFC02FE0)
  #define BLCFG3          (*(unsigned *)0xBFC02FE0)
  #define BLCFG2          (*(unsigned *)0xBFC02FE4)
  #define BLCFG1          (*(unsigned *)0xBFC02FE8)
  #define BLCFG0          (*(unsigned *)0xBFC02FEC)
#endif

/*
 * BLCFG0   APP_FLASH_START
 * BLCFG1   APP_FLASH_END + 1
 * BLCFG2   APP_START_ADDR (0: APP_FLASH_START)
 */
  struct blcfg3 {
    unsigned REDLED_BIT:4;
    unsigned REDLED_PORT:3;	/* 0 A/1 B/... */
    unsigned reserved1:1;	/* 0 */

    unsigned GRNLED_BIT:4;
    unsigned GRNLED_PORT:3;
    unsigned reserved2:1;	/* 0 */

    unsigned BUT_BIT:4;
    unsigned BUT_PORT:3;
    unsigned reserved3:1;	/* 0 */

    unsigned REDLED_TYPE:2; /* 0: LAT_SET  type
			       1: LAT_CLR  type
			       2: TRIS_SET type
			       3: TRIS_CLR type */
    unsigned GRNLED_TYPE:2;
    unsigned BUT_TYPE:1;    /* 0: NOT-PULLUP  1 : PULLUP */
    unsigned reserved:3;	/* 000 */
  };
 #define BLCFG0_INIT(val) \
    unsigned __attribute__((section(".bl_config0"))) _bl_config0 = val
 #define BLCFG1_INIT(val) \
    unsigned __attribute__((section(".bl_config1"))) _bl_config1 = val
 #define BLCFG2_INIT(val) \
    unsigned __attribute__((section(".bl_config2"))) _bl_config2 = val
 #define BLCFG3_INIT(...) \
    struct blcfg3 __attribute__((section(".bl_config3"))) \
	 _bl_config3 = {__VA_ARGS__}

#define BOOT_SECTION __attribute__((section(".boot")))

#endif /* _JZ_P32MX_BLCFG_H_ */
