#ifndef _PIC32MX_4XX_REGS_H_
#define _PIC32MX_4XX_REGS_H_


#ifdef _USE_SFRS_BASE_ADDR
  extern const void * _sfrs_base_addr_0;
  extern const void * _sfrs_base_addr_1;
#else
#define _sfrs_base_addr_0	((const void *)0xBF800000)
#define _sfrs_base_addr_1	((const void *)0xBF880000)
#endif

#define _SFRS_ADDR(x) ( _sfrs_base_addr_ ## x )

#define  _WDTCON           ( _SFRS_ADDR(0) + 0x0000)
#define  _WDTCONCLR        ( _SFRS_ADDR(0) + 0x0004)
#define  _WDTCONSET        ( _SFRS_ADDR(0) + 0x0008)
#define  _WDTCONINV        ( _SFRS_ADDR(0) + 0x000C)
#define  _RTCCON           ( _SFRS_ADDR(0) + 0x0200)
#define  _RTCCONCLR        ( _SFRS_ADDR(0) + 0x0204)
#define  _RTCCONSET        ( _SFRS_ADDR(0) + 0x0208)
#define  _RTCCONINV        ( _SFRS_ADDR(0) + 0x020C)
#define  _RTCALRM          ( _SFRS_ADDR(0) + 0x0210)
#define  _RTCALRMCLR       ( _SFRS_ADDR(0) + 0x0214)
#define  _RTCALRMSET       ( _SFRS_ADDR(0) + 0x0218)
#define  _RTCALRMINV       ( _SFRS_ADDR(0) + 0x021C)
#define  _RTCTIME          ( _SFRS_ADDR(0) + 0x0220)
#define  _RTCTIMECLR       ( _SFRS_ADDR(0) + 0x0224)
#define  _RTCTIMESET       ( _SFRS_ADDR(0) + 0x0228)
#define  _RTCTIMEINV       ( _SFRS_ADDR(0) + 0x022C)
#define  _RTCDATE          ( _SFRS_ADDR(0) + 0x0230)
#define  _RTCDATECLR       ( _SFRS_ADDR(0) + 0x0234)
#define  _RTCDATESET       ( _SFRS_ADDR(0) + 0x0238)
#define  _RTCDATEINV       ( _SFRS_ADDR(0) + 0x023C)
#define  _ALRMTIME         ( _SFRS_ADDR(0) + 0x0240)
#define  _ALRMTIMECLR      ( _SFRS_ADDR(0) + 0x0244)
#define  _ALRMTIMESET      ( _SFRS_ADDR(0) + 0x0248)
#define  _ALRMTIMEINV      ( _SFRS_ADDR(0) + 0x024C)
#define  _ALRMDATE         ( _SFRS_ADDR(0) + 0x0250)
#define  _ALRMDATECLR      ( _SFRS_ADDR(0) + 0x0254)
#define  _ALRMDATESET      ( _SFRS_ADDR(0) + 0x0258)
#define  _ALRMDATEINV      ( _SFRS_ADDR(0) + 0x025C)
#define  _T1CON            ( _SFRS_ADDR(0) + 0x0600)
#define  _T1CONCLR         ( _SFRS_ADDR(0) + 0x0604)
#define  _T1CONSET         ( _SFRS_ADDR(0) + 0x0608)
#define  _T1CONINV         ( _SFRS_ADDR(0) + 0x060C)
#define  _TMR1             ( _SFRS_ADDR(0) + 0x0610)
#define  _TMR1CLR          ( _SFRS_ADDR(0) + 0x0614)
#define  _TMR1SET          ( _SFRS_ADDR(0) + 0x0618)
#define  _TMR1INV          ( _SFRS_ADDR(0) + 0x061C)
#define  _PR1              ( _SFRS_ADDR(0) + 0x0620)
#define  _PR1CLR           ( _SFRS_ADDR(0) + 0x0624)
#define  _PR1SET           ( _SFRS_ADDR(0) + 0x0628)
#define  _PR1INV           ( _SFRS_ADDR(0) + 0x062C)
#define  _T2CON            ( _SFRS_ADDR(0) + 0x0800)
#define  _T2CONCLR         ( _SFRS_ADDR(0) + 0x0804)
#define  _T2CONSET         ( _SFRS_ADDR(0) + 0x0808)
#define  _T2CONINV         ( _SFRS_ADDR(0) + 0x080C)
#define  _TMR2             ( _SFRS_ADDR(0) + 0x0810)
#define  _TMR2CLR          ( _SFRS_ADDR(0) + 0x0814)
#define  _TMR2SET          ( _SFRS_ADDR(0) + 0x0818)
#define  _TMR2INV          ( _SFRS_ADDR(0) + 0x081C)
#define  _PR2              ( _SFRS_ADDR(0) + 0x0820)
#define  _PR2CLR           ( _SFRS_ADDR(0) + 0x0824)
#define  _PR2SET           ( _SFRS_ADDR(0) + 0x0828)
#define  _PR2INV           ( _SFRS_ADDR(0) + 0x082C)
#define  _T3CON            ( _SFRS_ADDR(0) + 0x0A00)
#define  _T3CONCLR         ( _SFRS_ADDR(0) + 0x0A04)
#define  _T3CONSET         ( _SFRS_ADDR(0) + 0x0A08)
#define  _T3CONINV         ( _SFRS_ADDR(0) + 0x0A0C)
#define  _TMR3             ( _SFRS_ADDR(0) + 0x0A10)
#define  _TMR3CLR          ( _SFRS_ADDR(0) + 0x0A14)
#define  _TMR3SET          ( _SFRS_ADDR(0) + 0x0A18)
#define  _TMR3INV          ( _SFRS_ADDR(0) + 0x0A1C)
#define  _PR3              ( _SFRS_ADDR(0) + 0x0A20)
#define  _PR3CLR           ( _SFRS_ADDR(0) + 0x0A24)
#define  _PR3SET           ( _SFRS_ADDR(0) + 0x0A28)
#define  _PR3INV           ( _SFRS_ADDR(0) + 0x0A2C)
#define  _T4CON            ( _SFRS_ADDR(0) + 0x0C00)
#define  _T4CONCLR         ( _SFRS_ADDR(0) + 0x0C04)
#define  _T4CONSET         ( _SFRS_ADDR(0) + 0x0C08)
#define  _T4CONINV         ( _SFRS_ADDR(0) + 0x0C0C)
#define  _TMR4             ( _SFRS_ADDR(0) + 0x0C10)
#define  _TMR4CLR          ( _SFRS_ADDR(0) + 0x0C14)
#define  _TMR4SET          ( _SFRS_ADDR(0) + 0x0C18)
#define  _TMR4INV          ( _SFRS_ADDR(0) + 0x0C1C)
#define  _PR4              ( _SFRS_ADDR(0) + 0x0C20)
#define  _PR4CLR           ( _SFRS_ADDR(0) + 0x0C24)
#define  _PR4SET           ( _SFRS_ADDR(0) + 0x0C28)
#define  _PR4INV           ( _SFRS_ADDR(0) + 0x0C2C)
#define  _T5CON            ( _SFRS_ADDR(0) + 0x0E00)
#define  _T5CONCLR         ( _SFRS_ADDR(0) + 0x0E04)
#define  _T5CONSET         ( _SFRS_ADDR(0) + 0x0E08)
#define  _T5CONINV         ( _SFRS_ADDR(0) + 0x0E0C)
#define  _TMR5             ( _SFRS_ADDR(0) + 0x0E10)
#define  _TMR5CLR          ( _SFRS_ADDR(0) + 0x0E14)
#define  _TMR5SET          ( _SFRS_ADDR(0) + 0x0E18)
#define  _TMR5INV          ( _SFRS_ADDR(0) + 0x0E1C)
#define  _PR5              ( _SFRS_ADDR(0) + 0x0E20)
#define  _PR5CLR           ( _SFRS_ADDR(0) + 0x0E24)
#define  _PR5SET           ( _SFRS_ADDR(0) + 0x0E28)
#define  _PR5INV           ( _SFRS_ADDR(0) + 0x0E2C)
#define  _IC1CON           ( _SFRS_ADDR(0) + 0x2000)
#define  _IC1CONCLR        ( _SFRS_ADDR(0) + 0x2004)
#define  _IC1CONSET        ( _SFRS_ADDR(0) + 0x2008)
#define  _IC1CONINV        ( _SFRS_ADDR(0) + 0x200C)
#define  _IC1BUF           ( _SFRS_ADDR(0) + 0x2010)
#define  _IC2CON           ( _SFRS_ADDR(0) + 0x2200)
#define  _IC2CONCLR        ( _SFRS_ADDR(0) + 0x2204)
#define  _IC2CONSET        ( _SFRS_ADDR(0) + 0x2208)
#define  _IC2CONINV        ( _SFRS_ADDR(0) + 0x220C)
#define  _IC2BUF           ( _SFRS_ADDR(0) + 0x2210)
#define  _IC3CON           ( _SFRS_ADDR(0) + 0x2400)
#define  _IC3CONCLR        ( _SFRS_ADDR(0) + 0x2404)
#define  _IC3CONSET        ( _SFRS_ADDR(0) + 0x2408)
#define  _IC3CONINV        ( _SFRS_ADDR(0) + 0x240C)
#define  _IC3BUF           ( _SFRS_ADDR(0) + 0x2410)
#define  _IC4CON           ( _SFRS_ADDR(0) + 0x2600)
#define  _IC4CONCLR        ( _SFRS_ADDR(0) + 0x2604)
#define  _IC4CONSET        ( _SFRS_ADDR(0) + 0x2608)
#define  _IC4CONINV        ( _SFRS_ADDR(0) + 0x260C)
#define  _IC4BUF           ( _SFRS_ADDR(0) + 0x2610)
#define  _IC5CON           ( _SFRS_ADDR(0) + 0x2800)
#define  _IC5CONCLR        ( _SFRS_ADDR(0) + 0x2804)
#define  _IC5CONSET        ( _SFRS_ADDR(0) + 0x2808)
#define  _IC5CONINV        ( _SFRS_ADDR(0) + 0x280C)
#define  _IC5BUF           ( _SFRS_ADDR(0) + 0x2810)
#define  _OC1CON           ( _SFRS_ADDR(0) + 0x3000)
#define  _OC1CONCLR        ( _SFRS_ADDR(0) + 0x3004)
#define  _OC1CONSET        ( _SFRS_ADDR(0) + 0x3008)
#define  _OC1CONINV        ( _SFRS_ADDR(0) + 0x300C)
#define  _OC1R             ( _SFRS_ADDR(0) + 0x3010)
#define  _OC1RCLR          ( _SFRS_ADDR(0) + 0x3014)
#define  _OC1RSET          ( _SFRS_ADDR(0) + 0x3018)
#define  _OC1RINV          ( _SFRS_ADDR(0) + 0x301C)
#define  _OC1RS            ( _SFRS_ADDR(0) + 0x3020)
#define  _OC1RSCLR         ( _SFRS_ADDR(0) + 0x3024)
#define  _OC1RSSET         ( _SFRS_ADDR(0) + 0x3028)
#define  _OC1RSINV         ( _SFRS_ADDR(0) + 0x302C)
#define  _OC2CON           ( _SFRS_ADDR(0) + 0x3200)
#define  _OC2CONCLR        ( _SFRS_ADDR(0) + 0x3204)
#define  _OC2CONSET        ( _SFRS_ADDR(0) + 0x3208)
#define  _OC2CONINV        ( _SFRS_ADDR(0) + 0x320C)
#define  _OC2R             ( _SFRS_ADDR(0) + 0x3210)
#define  _OC2RCLR          ( _SFRS_ADDR(0) + 0x3214)
#define  _OC2RSET          ( _SFRS_ADDR(0) + 0x3218)
#define  _OC2RINV          ( _SFRS_ADDR(0) + 0x321C)
#define  _OC2RS            ( _SFRS_ADDR(0) + 0x3220)
#define  _OC2RSCLR         ( _SFRS_ADDR(0) + 0x3224)
#define  _OC2RSSET         ( _SFRS_ADDR(0) + 0x3228)
#define  _OC2RSINV         ( _SFRS_ADDR(0) + 0x322C)
#define  _OC3CON           ( _SFRS_ADDR(0) + 0x3400)
#define  _OC3CONCLR        ( _SFRS_ADDR(0) + 0x3404)
#define  _OC3CONSET        ( _SFRS_ADDR(0) + 0x3408)
#define  _OC3CONINV        ( _SFRS_ADDR(0) + 0x340C)
#define  _OC3R             ( _SFRS_ADDR(0) + 0x3410)
#define  _OC3RCLR          ( _SFRS_ADDR(0) + 0x3414)
#define  _OC3RSET          ( _SFRS_ADDR(0) + 0x3418)
#define  _OC3RINV          ( _SFRS_ADDR(0) + 0x341C)
#define  _OC3RS            ( _SFRS_ADDR(0) + 0x3420)
#define  _OC3RSCLR         ( _SFRS_ADDR(0) + 0x3424)
#define  _OC3RSSET         ( _SFRS_ADDR(0) + 0x3428)
#define  _OC3RSINV         ( _SFRS_ADDR(0) + 0x342C)
#define  _OC4CON           ( _SFRS_ADDR(0) + 0x3600)
#define  _OC4CONCLR        ( _SFRS_ADDR(0) + 0x3604)
#define  _OC4CONSET        ( _SFRS_ADDR(0) + 0x3608)
#define  _OC4CONINV        ( _SFRS_ADDR(0) + 0x360C)
#define  _OC4R             ( _SFRS_ADDR(0) + 0x3610)
#define  _OC4RCLR          ( _SFRS_ADDR(0) + 0x3614)
#define  _OC4RSET          ( _SFRS_ADDR(0) + 0x3618)
#define  _OC4RINV          ( _SFRS_ADDR(0) + 0x361C)
#define  _OC4RS            ( _SFRS_ADDR(0) + 0x3620)
#define  _OC4RSCLR         ( _SFRS_ADDR(0) + 0x3624)
#define  _OC4RSSET         ( _SFRS_ADDR(0) + 0x3628)
#define  _OC4RSINV         ( _SFRS_ADDR(0) + 0x362C)
#define  _OC5CON           ( _SFRS_ADDR(0) + 0x3800)
#define  _OC5CONCLR        ( _SFRS_ADDR(0) + 0x3804)
#define  _OC5CONSET        ( _SFRS_ADDR(0) + 0x3808)
#define  _OC5CONINV        ( _SFRS_ADDR(0) + 0x380C)
#define  _OC5R             ( _SFRS_ADDR(0) + 0x3810)
#define  _OC5RCLR          ( _SFRS_ADDR(0) + 0x3814)
#define  _OC5RSET          ( _SFRS_ADDR(0) + 0x3818)
#define  _OC5RINV          ( _SFRS_ADDR(0) + 0x381C)
#define  _OC5RS            ( _SFRS_ADDR(0) + 0x3820)
#define  _OC5RSCLR         ( _SFRS_ADDR(0) + 0x3824)
#define  _OC5RSSET         ( _SFRS_ADDR(0) + 0x3828)
#define  _OC5RSINV         ( _SFRS_ADDR(0) + 0x382C)
#define  _I2C1CON          ( _SFRS_ADDR(0) + 0x5000)
#define  _I2C1CONCLR       ( _SFRS_ADDR(0) + 0x5004)
#define  _I2C1CONSET       ( _SFRS_ADDR(0) + 0x5008)
#define  _I2C1CONINV       ( _SFRS_ADDR(0) + 0x500C)
#define  _I2C1STAT         ( _SFRS_ADDR(0) + 0x5010)
#define  _I2C1STATCLR      ( _SFRS_ADDR(0) + 0x5014)
#define  _I2C1STATSET      ( _SFRS_ADDR(0) + 0x5018)
#define  _I2C1STATINV      ( _SFRS_ADDR(0) + 0x501C)
#define  _I2C1ADD          ( _SFRS_ADDR(0) + 0x5020)
#define  _I2C1ADDCLR       ( _SFRS_ADDR(0) + 0x5024)
#define  _I2C1ADDSET       ( _SFRS_ADDR(0) + 0x5028)
#define  _I2C1ADDINV       ( _SFRS_ADDR(0) + 0x502C)
#define  _I2C1MSK          ( _SFRS_ADDR(0) + 0x5030)
#define  _I2C1MSKCLR       ( _SFRS_ADDR(0) + 0x5034)
#define  _I2C1MSKSET       ( _SFRS_ADDR(0) + 0x5038)
#define  _I2C1MSKINV       ( _SFRS_ADDR(0) + 0x503C)
#define  _I2C1BRG          ( _SFRS_ADDR(0) + 0x5040)
#define  _I2C1BRGCLR       ( _SFRS_ADDR(0) + 0x5044)
#define  _I2C1BRGSET       ( _SFRS_ADDR(0) + 0x5048)
#define  _I2C1BRGINV       ( _SFRS_ADDR(0) + 0x504C)
#define  _I2C1TRN          ( _SFRS_ADDR(0) + 0x5050)
#define  _I2C1TRNCLR       ( _SFRS_ADDR(0) + 0x5054)
#define  _I2C1TRNSET       ( _SFRS_ADDR(0) + 0x5058)
#define  _I2C1TRNINV       ( _SFRS_ADDR(0) + 0x505C)
#define  _I2C1RCV          ( _SFRS_ADDR(0) + 0x5060)
#define  _I2C2CON          ( _SFRS_ADDR(0) + 0x5200)
#define  _I2C2CONCLR       ( _SFRS_ADDR(0) + 0x5204)
#define  _I2C2CONSET       ( _SFRS_ADDR(0) + 0x5208)
#define  _I2C2CONINV       ( _SFRS_ADDR(0) + 0x520C)
#define  _I2C2STAT         ( _SFRS_ADDR(0) + 0x5210)
#define  _I2C2STATCLR      ( _SFRS_ADDR(0) + 0x5214)
#define  _I2C2STATSET      ( _SFRS_ADDR(0) + 0x5218)
#define  _I2C2STATINV      ( _SFRS_ADDR(0) + 0x521C)
#define  _I2C2ADD          ( _SFRS_ADDR(0) + 0x5220)
#define  _I2C2ADDCLR       ( _SFRS_ADDR(0) + 0x5224)
#define  _I2C2ADDSET       ( _SFRS_ADDR(0) + 0x5228)
#define  _I2C2ADDINV       ( _SFRS_ADDR(0) + 0x522C)
#define  _I2C2MSK          ( _SFRS_ADDR(0) + 0x5230)
#define  _I2C2MSKCLR       ( _SFRS_ADDR(0) + 0x5234)
#define  _I2C2MSKSET       ( _SFRS_ADDR(0) + 0x5238)
#define  _I2C2MSKINV       ( _SFRS_ADDR(0) + 0x523C)
#define  _I2C2BRG          ( _SFRS_ADDR(0) + 0x5240)
#define  _I2C2BRGCLR       ( _SFRS_ADDR(0) + 0x5244)
#define  _I2C2BRGSET       ( _SFRS_ADDR(0) + 0x5248)
#define  _I2C2BRGINV       ( _SFRS_ADDR(0) + 0x524C)
#define  _I2C2TRN          ( _SFRS_ADDR(0) + 0x5250)
#define  _I2C2TRNCLR       ( _SFRS_ADDR(0) + 0x5254)
#define  _I2C2TRNSET       ( _SFRS_ADDR(0) + 0x5258)
#define  _I2C2TRNINV       ( _SFRS_ADDR(0) + 0x525C)
#define  _I2C2RCV          ( _SFRS_ADDR(0) + 0x5260)
#define  _SPI1CON          ( _SFRS_ADDR(0) + 0x5800)
#define  _SPI1CONCLR       ( _SFRS_ADDR(0) + 0x5804)
#define  _SPI1CONSET       ( _SFRS_ADDR(0) + 0x5808)
#define  _SPI1CONINV       ( _SFRS_ADDR(0) + 0x580C)
#define  _SPI1STAT         ( _SFRS_ADDR(0) + 0x5810)
#define  _SPI1STATCLR      ( _SFRS_ADDR(0) + 0x5814)
#define  _SPI1STATSET      ( _SFRS_ADDR(0) + 0x5818)
#define  _SPI1STATINV      ( _SFRS_ADDR(0) + 0x581C)
#define  _SPI1BUF          ( _SFRS_ADDR(0) + 0x5820)
#define  _SPI1BRG          ( _SFRS_ADDR(0) + 0x5830)
#define  _SPI1BRGCLR       ( _SFRS_ADDR(0) + 0x5834)
#define  _SPI1BRGSET       ( _SFRS_ADDR(0) + 0x5838)
#define  _SPI1BRGINV       ( _SFRS_ADDR(0) + 0x583C)
#define  _SPI2CON          ( _SFRS_ADDR(0) + 0x5A00)
#define  _SPI2CONCLR       ( _SFRS_ADDR(0) + 0x5A04)
#define  _SPI2CONSET       ( _SFRS_ADDR(0) + 0x5A08)
#define  _SPI2CONINV       ( _SFRS_ADDR(0) + 0x5A0C)
#define  _SPI2STAT         ( _SFRS_ADDR(0) + 0x5A10)
#define  _SPI2STATCLR      ( _SFRS_ADDR(0) + 0x5A14)
#define  _SPI2STATSET      ( _SFRS_ADDR(0) + 0x5A18)
#define  _SPI2STATINV      ( _SFRS_ADDR(0) + 0x5A1C)
#define  _SPI2BUF          ( _SFRS_ADDR(0) + 0x5A20)
#define  _SPI2BRG          ( _SFRS_ADDR(0) + 0x5A30)
#define  _SPI2BRGCLR       ( _SFRS_ADDR(0) + 0x5A34)
#define  _SPI2BRGSET       ( _SFRS_ADDR(0) + 0x5A38)
#define  _SPI2BRGINV       ( _SFRS_ADDR(0) + 0x5A3C)
#define  _U1MODE           ( _SFRS_ADDR(0) + 0x6000)
#define  _U1MODECLR        ( _SFRS_ADDR(0) + 0x6004)
#define  _U1MODESET        ( _SFRS_ADDR(0) + 0x6008)
#define  _U1MODEINV        ( _SFRS_ADDR(0) + 0x600C)
#define  _U1STA            ( _SFRS_ADDR(0) + 0x6010)
#define  _U1STACLR         ( _SFRS_ADDR(0) + 0x6014)
#define  _U1STASET         ( _SFRS_ADDR(0) + 0x6018)
#define  _U1STAINV         ( _SFRS_ADDR(0) + 0x601C)
#define  _U1TXREG          ( _SFRS_ADDR(0) + 0x6020)
#define  _U1RXREG          ( _SFRS_ADDR(0) + 0x6030)
#define  _U1BRG            ( _SFRS_ADDR(0) + 0x6040)
#define  _U1BRGCLR         ( _SFRS_ADDR(0) + 0x6044)
#define  _U1BRGSET         ( _SFRS_ADDR(0) + 0x6048)
#define  _U1BRGINV         ( _SFRS_ADDR(0) + 0x604C)
#define  _U2MODE           ( _SFRS_ADDR(0) + 0x6200)
#define  _U2MODECLR        ( _SFRS_ADDR(0) + 0x6204)
#define  _U2MODESET        ( _SFRS_ADDR(0) + 0x6208)
#define  _U2MODEINV        ( _SFRS_ADDR(0) + 0x620C)
#define  _U2STA            ( _SFRS_ADDR(0) + 0x6210)
#define  _U2STACLR         ( _SFRS_ADDR(0) + 0x6214)
#define  _U2STASET         ( _SFRS_ADDR(0) + 0x6218)
#define  _U2STAINV         ( _SFRS_ADDR(0) + 0x621C)
#define  _U2TXREG          ( _SFRS_ADDR(0) + 0x6220)
#define  _U2RXREG          ( _SFRS_ADDR(0) + 0x6230)
#define  _U2BRG            ( _SFRS_ADDR(0) + 0x6240)
#define  _U2BRGCLR         ( _SFRS_ADDR(0) + 0x6244)
#define  _U2BRGSET         ( _SFRS_ADDR(0) + 0x6248)
#define  _U2BRGINV         ( _SFRS_ADDR(0) + 0x624C)
#define  _PMCON            ( _SFRS_ADDR(0) + 0x7000)
#define  _PMCONCLR         ( _SFRS_ADDR(0) + 0x7004)
#define  _PMCONSET         ( _SFRS_ADDR(0) + 0x7008)
#define  _PMCONINV         ( _SFRS_ADDR(0) + 0x700C)
#define  _PMMODE           ( _SFRS_ADDR(0) + 0x7010)
#define  _PMMODECLR        ( _SFRS_ADDR(0) + 0x7014)
#define  _PMMODESET        ( _SFRS_ADDR(0) + 0x7018)
#define  _PMMODEINV        ( _SFRS_ADDR(0) + 0x701C)
#define  _PMADDR           ( _SFRS_ADDR(0) + 0x7020)
#define  _PMADDRCLR        ( _SFRS_ADDR(0) + 0x7024)
#define  _PMADDRSET        ( _SFRS_ADDR(0) + 0x7028)
#define  _PMADDRINV        ( _SFRS_ADDR(0) + 0x702C)
#define  _PMDOUT           ( _SFRS_ADDR(0) + 0x7030)
#define  _PMDOUTCLR        ( _SFRS_ADDR(0) + 0x7034)
#define  _PMDOUTSET        ( _SFRS_ADDR(0) + 0x7038)
#define  _PMDOUTINV        ( _SFRS_ADDR(0) + 0x703C)
#define  _PMDIN            ( _SFRS_ADDR(0) + 0x7040)
#define  _PMDINCLR         ( _SFRS_ADDR(0) + 0x7044)
#define  _PMDINSET         ( _SFRS_ADDR(0) + 0x7048)
#define  _PMDININV         ( _SFRS_ADDR(0) + 0x704C)
#define  _PMAEN            ( _SFRS_ADDR(0) + 0x7050)
#define  _PMAENCLR         ( _SFRS_ADDR(0) + 0x7054)
#define  _PMAENSET         ( _SFRS_ADDR(0) + 0x7058)
#define  _PMAENINV         ( _SFRS_ADDR(0) + 0x705C)
#define  _PMSTAT           ( _SFRS_ADDR(0) + 0x7060)
#define  _PMSTATCLR        ( _SFRS_ADDR(0) + 0x7064)
#define  _PMSTATSET        ( _SFRS_ADDR(0) + 0x7068)
#define  _PMSTATINV        ( _SFRS_ADDR(0) + 0x706C)
#define  _AD1CON1          ( _SFRS_ADDR(0) + 0x9000)
#define  _AD1CON1CLR       ( _SFRS_ADDR(0) + 0x9004)
#define  _AD1CON1SET       ( _SFRS_ADDR(0) + 0x9008)
#define  _AD1CON1INV       ( _SFRS_ADDR(0) + 0x900C)
#define  _AD1CON2          ( _SFRS_ADDR(0) + 0x9010)
#define  _AD1CON2CLR       ( _SFRS_ADDR(0) + 0x9014)
#define  _AD1CON2SET       ( _SFRS_ADDR(0) + 0x9018)
#define  _AD1CON2INV       ( _SFRS_ADDR(0) + 0x901C)
#define  _AD1CON3          ( _SFRS_ADDR(0) + 0x9020)
#define  _AD1CON3CLR       ( _SFRS_ADDR(0) + 0x9024)
#define  _AD1CON3SET       ( _SFRS_ADDR(0) + 0x9028)
#define  _AD1CON3INV       ( _SFRS_ADDR(0) + 0x902C)
#define  _AD1CHS           ( _SFRS_ADDR(0) + 0x9040)
#define  _AD1CHSCLR        ( _SFRS_ADDR(0) + 0x9044)
#define  _AD1CHSSET        ( _SFRS_ADDR(0) + 0x9048)
#define  _AD1CHSINV        ( _SFRS_ADDR(0) + 0x904C)
#define  _AD1CSSL          ( _SFRS_ADDR(0) + 0x9050)
#define  _AD1CSSLCLR       ( _SFRS_ADDR(0) + 0x9054)
#define  _AD1CSSLSET       ( _SFRS_ADDR(0) + 0x9058)
#define  _AD1CSSLINV       ( _SFRS_ADDR(0) + 0x905C)
#define  _AD1PCFG          ( _SFRS_ADDR(0) + 0x9060)
#define  _AD1PCFGCLR       ( _SFRS_ADDR(0) + 0x9064)
#define  _AD1PCFGSET       ( _SFRS_ADDR(0) + 0x9068)
#define  _AD1PCFGINV       ( _SFRS_ADDR(0) + 0x906C)
#define  _ADC1BUF0         ( _SFRS_ADDR(0) + 0x9070)
#define  _ADC1BUF1         ( _SFRS_ADDR(0) + 0x9080)
#define  _ADC1BUF2         ( _SFRS_ADDR(0) + 0x9090)
#define  _ADC1BUF3         ( _SFRS_ADDR(0) + 0x90A0)
#define  _ADC1BUF4         ( _SFRS_ADDR(0) + 0x90B0)
#define  _ADC1BUF5         ( _SFRS_ADDR(0) + 0x90C0)
#define  _ADC1BUF6         ( _SFRS_ADDR(0) + 0x90D0)
#define  _ADC1BUF7         ( _SFRS_ADDR(0) + 0x90E0)
#define  _ADC1BUF8         ( _SFRS_ADDR(0) + 0x90F0)
#define  _ADC1BUF9         ( _SFRS_ADDR(0) + 0x9100)
#define  _ADC1BUFA         ( _SFRS_ADDR(0) + 0x9110)
#define  _ADC1BUFB         ( _SFRS_ADDR(0) + 0x9120)
#define  _ADC1BUFC         ( _SFRS_ADDR(0) + 0x9130)
#define  _ADC1BUFD         ( _SFRS_ADDR(0) + 0x9140)
#define  _ADC1BUFE         ( _SFRS_ADDR(0) + 0x9150)
#define  _ADC1BUFF         ( _SFRS_ADDR(0) + 0x9160)
#define  _CVRCON           ( _SFRS_ADDR(0) + 0x9800)
#define  _CVRCONCLR        ( _SFRS_ADDR(0) + 0x9804)
#define  _CVRCONSET        ( _SFRS_ADDR(0) + 0x9808)
#define  _CVRCONINV        ( _SFRS_ADDR(0) + 0x980C)
#define  _CM1CON           ( _SFRS_ADDR(0) + 0xA000)
#define  _CM1CONCLR        ( _SFRS_ADDR(0) + 0xA004)
#define  _CM1CONSET        ( _SFRS_ADDR(0) + 0xA008)
#define  _CM1CONINV        ( _SFRS_ADDR(0) + 0xA00C)
#define  _CM2CON           ( _SFRS_ADDR(0) + 0xA010)
#define  _CM2CONCLR        ( _SFRS_ADDR(0) + 0xA014)
#define  _CM2CONSET        ( _SFRS_ADDR(0) + 0xA018)
#define  _CM2CONINV        ( _SFRS_ADDR(0) + 0xA01C)
#define  _CMSTAT           ( _SFRS_ADDR(0) + 0xA060)
#define  _CMSTATCLR        ( _SFRS_ADDR(0) + 0xA064)
#define  _CMSTATSET        ( _SFRS_ADDR(0) + 0xA068)
#define  _CMSTATINV        ( _SFRS_ADDR(0) + 0xA06C)
#define  _OSCCON           ( _SFRS_ADDR(0) + 0xF000)
#define  _OSCCONCLR        ( _SFRS_ADDR(0) + 0xF004)
#define  _OSCCONSET        ( _SFRS_ADDR(0) + 0xF008)
#define  _OSCCONINV        ( _SFRS_ADDR(0) + 0xF00C)
#define  _OSCTUN           ( _SFRS_ADDR(0) + 0xF010)
#define  _OSCTUNCLR        ( _SFRS_ADDR(0) + 0xF014)
#define  _OSCTUNSET        ( _SFRS_ADDR(0) + 0xF018)
#define  _OSCTUNINV        ( _SFRS_ADDR(0) + 0xF01C)
#define  _DDPCON           ( _SFRS_ADDR(0) + 0xF200)
#define  _DEVID            ( _SFRS_ADDR(0) + 0xF220)
#define  _SYSKEY           ( _SFRS_ADDR(0) + 0xF230)
#define  _SYSKEYCLR        ( _SFRS_ADDR(0) + 0xF234)
#define  _SYSKEYSET        ( _SFRS_ADDR(0) + 0xF238)
#define  _SYSKEYINV        ( _SFRS_ADDR(0) + 0xF23C)
#define  _NVMCON           ( _SFRS_ADDR(0) + 0xF400)
#define  _NVMCONCLR        ( _SFRS_ADDR(0) + 0xF404)
#define  _NVMCONSET        ( _SFRS_ADDR(0) + 0xF408)
#define  _NVMCONINV        ( _SFRS_ADDR(0) + 0xF40C)
#define  _NVMKEY           ( _SFRS_ADDR(0) + 0xF410)
#define  _NVMADDR          ( _SFRS_ADDR(0) + 0xF420)
#define  _NVMADDRCLR       ( _SFRS_ADDR(0) + 0xF424)
#define  _NVMADDRSET       ( _SFRS_ADDR(0) + 0xF428)
#define  _NVMADDRINV       ( _SFRS_ADDR(0) + 0xF42C)
#define  _NVMDATA          ( _SFRS_ADDR(0) + 0xF430)
#define  _NVMSRCADDR       ( _SFRS_ADDR(0) + 0xF440)
#define  _RCON             ( _SFRS_ADDR(0) + 0xF600)
#define  _RCONCLR          ( _SFRS_ADDR(0) + 0xF604)
#define  _RCONSET          ( _SFRS_ADDR(0) + 0xF608)
#define  _RCONINV          ( _SFRS_ADDR(0) + 0xF60C)
#define  _RSWRST           ( _SFRS_ADDR(0) + 0xF610)
#define  _RSWRSTCLR        ( _SFRS_ADDR(0) + 0xF614)
#define  _RSWRSTSET        ( _SFRS_ADDR(0) + 0xF618)
#define  _RSWRSTINV        ( _SFRS_ADDR(0) + 0xF61C)
#define  __DDPSTAT         ( _SFRS_ADDR(1) + 0x0140)
#define  __STRO            ( _SFRS_ADDR(1) + 0x0170)
#define  __STROCLR         ( _SFRS_ADDR(1) + 0x0174)
#define  __STROSET         ( _SFRS_ADDR(1) + 0x0178)
#define  __STROINV         ( _SFRS_ADDR(1) + 0x017C)
#define  __APPO            ( _SFRS_ADDR(1) + 0x0180)
#define  __APPOCLR         ( _SFRS_ADDR(1) + 0x0184)
#define  __APPOSET         ( _SFRS_ADDR(1) + 0x0188)
#define  __APPOINV         ( _SFRS_ADDR(1) + 0x018C)
#define  __APPI            ( _SFRS_ADDR(1) + 0x0190)
#define  _INTCON           ( _SFRS_ADDR(1) + 0x1000)
#define  _INTCONCLR        ( _SFRS_ADDR(1) + 0x1004)
#define  _INTCONSET        ( _SFRS_ADDR(1) + 0x1008)
#define  _INTCONINV        ( _SFRS_ADDR(1) + 0x100C)
#define  _INTSTAT          ( _SFRS_ADDR(1) + 0x1010)
#define  _IPTMR            ( _SFRS_ADDR(1) + 0x1020)
#define  _IPTMRCLR         ( _SFRS_ADDR(1) + 0x1024)
#define  _IPTMRSET         ( _SFRS_ADDR(1) + 0x1028)
#define  _IPTMRINV         ( _SFRS_ADDR(1) + 0x102C)
#define  _IFS0             ( _SFRS_ADDR(1) + 0x1030)
#define  _IFS0CLR          ( _SFRS_ADDR(1) + 0x1034)
#define  _IFS0SET          ( _SFRS_ADDR(1) + 0x1038)
#define  _IFS0INV          ( _SFRS_ADDR(1) + 0x103C)
#define  _IFS1             ( _SFRS_ADDR(1) + 0x1040)
#define  _IFS1CLR          ( _SFRS_ADDR(1) + 0x1044)
#define  _IFS1SET          ( _SFRS_ADDR(1) + 0x1048)
#define  _IFS1INV          ( _SFRS_ADDR(1) + 0x104C)
#define  _IEC0             ( _SFRS_ADDR(1) + 0x1060)
#define  _IEC0CLR          ( _SFRS_ADDR(1) + 0x1064)
#define  _IEC0SET          ( _SFRS_ADDR(1) + 0x1068)
#define  _IEC0INV          ( _SFRS_ADDR(1) + 0x106C)
#define  _IEC1             ( _SFRS_ADDR(1) + 0x1070)
#define  _IEC1CLR          ( _SFRS_ADDR(1) + 0x1074)
#define  _IEC1SET          ( _SFRS_ADDR(1) + 0x1078)
#define  _IEC1INV          ( _SFRS_ADDR(1) + 0x107C)
#define  _IPC0             ( _SFRS_ADDR(1) + 0x1090)
#define  _IPC0CLR          ( _SFRS_ADDR(1) + 0x1094)
#define  _IPC0SET          ( _SFRS_ADDR(1) + 0x1098)
#define  _IPC0INV          ( _SFRS_ADDR(1) + 0x109C)
#define  _IPC1             ( _SFRS_ADDR(1) + 0x10A0)
#define  _IPC1CLR          ( _SFRS_ADDR(1) + 0x10A4)
#define  _IPC1SET          ( _SFRS_ADDR(1) + 0x10A8)
#define  _IPC1INV          ( _SFRS_ADDR(1) + 0x10AC)
#define  _IPC2             ( _SFRS_ADDR(1) + 0x10B0)
#define  _IPC2CLR          ( _SFRS_ADDR(1) + 0x10B4)
#define  _IPC2SET          ( _SFRS_ADDR(1) + 0x10B8)
#define  _IPC2INV          ( _SFRS_ADDR(1) + 0x10BC)
#define  _IPC3             ( _SFRS_ADDR(1) + 0x10C0)
#define  _IPC3CLR          ( _SFRS_ADDR(1) + 0x10C4)
#define  _IPC3SET          ( _SFRS_ADDR(1) + 0x10C8)
#define  _IPC3INV          ( _SFRS_ADDR(1) + 0x10CC)
#define  _IPC4             ( _SFRS_ADDR(1) + 0x10D0)
#define  _IPC4CLR          ( _SFRS_ADDR(1) + 0x10D4)
#define  _IPC4SET          ( _SFRS_ADDR(1) + 0x10D8)
#define  _IPC4INV          ( _SFRS_ADDR(1) + 0x10DC)
#define  _IPC5             ( _SFRS_ADDR(1) + 0x10E0)
#define  _IPC5CLR          ( _SFRS_ADDR(1) + 0x10E4)
#define  _IPC5SET          ( _SFRS_ADDR(1) + 0x10E8)
#define  _IPC5INV          ( _SFRS_ADDR(1) + 0x10EC)
#define  _IPC6             ( _SFRS_ADDR(1) + 0x10F0)
#define  _IPC6CLR          ( _SFRS_ADDR(1) + 0x10F4)
#define  _IPC6SET          ( _SFRS_ADDR(1) + 0x10F8)
#define  _IPC6INV          ( _SFRS_ADDR(1) + 0x10FC)
#define  _IPC7             ( _SFRS_ADDR(1) + 0x1100)
#define  _IPC7CLR          ( _SFRS_ADDR(1) + 0x1104)
#define  _IPC7SET          ( _SFRS_ADDR(1) + 0x1108)
#define  _IPC7INV          ( _SFRS_ADDR(1) + 0x110C)
#define  _IPC8             ( _SFRS_ADDR(1) + 0x1110)
#define  _IPC8CLR          ( _SFRS_ADDR(1) + 0x1114)
#define  _IPC8SET          ( _SFRS_ADDR(1) + 0x1118)
#define  _IPC8INV          ( _SFRS_ADDR(1) + 0x111C)
#define  _IPC9             ( _SFRS_ADDR(1) + 0x1120)
#define  _IPC9CLR          ( _SFRS_ADDR(1) + 0x1124)
#define  _IPC9SET          ( _SFRS_ADDR(1) + 0x1128)
#define  _IPC9INV          ( _SFRS_ADDR(1) + 0x112C)
#define  _IPC11            ( _SFRS_ADDR(1) + 0x1140)
#define  _IPC11CLR         ( _SFRS_ADDR(1) + 0x1144)
#define  _IPC11SET         ( _SFRS_ADDR(1) + 0x1148)
#define  _IPC11INV         ( _SFRS_ADDR(1) + 0x114C)
#define  _BMXCON           ( _SFRS_ADDR(1) + 0x2000)
#define  _BMXCONCLR        ( _SFRS_ADDR(1) + 0x2004)
#define  _BMXCONSET        ( _SFRS_ADDR(1) + 0x2008)
#define  _BMXCONINV        ( _SFRS_ADDR(1) + 0x200C)
#define  _BMXDKPBA         ( _SFRS_ADDR(1) + 0x2010)
#define  _BMXDKPBACLR      ( _SFRS_ADDR(1) + 0x2014)
#define  _BMXDKPBASET      ( _SFRS_ADDR(1) + 0x2018)
#define  _BMXDKPBAINV      ( _SFRS_ADDR(1) + 0x201C)
#define  _BMXDUDBA         ( _SFRS_ADDR(1) + 0x2020)
#define  _BMXDUDBACLR      ( _SFRS_ADDR(1) + 0x2024)
#define  _BMXDUDBASET      ( _SFRS_ADDR(1) + 0x2028)
#define  _BMXDUDBAINV      ( _SFRS_ADDR(1) + 0x202C)
#define  _BMXDUPBA         ( _SFRS_ADDR(1) + 0x2030)
#define  _BMXDUPBACLR      ( _SFRS_ADDR(1) + 0x2034)
#define  _BMXDUPBASET      ( _SFRS_ADDR(1) + 0x2038)
#define  _BMXDUPBAINV      ( _SFRS_ADDR(1) + 0x203C)
#define  _BMXDRMSZ         ( _SFRS_ADDR(1) + 0x2040)
#define  _BMXPUPBA         ( _SFRS_ADDR(1) + 0x2050)
#define  _BMXPUPBACLR      ( _SFRS_ADDR(1) + 0x2054)
#define  _BMXPUPBASET      ( _SFRS_ADDR(1) + 0x2058)
#define  _BMXPUPBAINV      ( _SFRS_ADDR(1) + 0x205C)
#define  _BMXPFMSZ         ( _SFRS_ADDR(1) + 0x2060)
#define  _BMXBOOTSZ        ( _SFRS_ADDR(1) + 0x2070)
#define  _DMACON           ( _SFRS_ADDR(1) + 0x3000)
#define  _DMACONCLR        ( _SFRS_ADDR(1) + 0x3004)
#define  _DMACONSET        ( _SFRS_ADDR(1) + 0x3008)
#define  _DMACONINV        ( _SFRS_ADDR(1) + 0x300C)
#define  _DMASTAT          ( _SFRS_ADDR(1) + 0x3010)
#define  _DMASTATCLR       ( _SFRS_ADDR(1) + 0x3014)
#define  _DMASTATSET       ( _SFRS_ADDR(1) + 0x3018)
#define  _DMASTATINV       ( _SFRS_ADDR(1) + 0x301C)
#define  _DMAADDR          ( _SFRS_ADDR(1) + 0x3020)
#define  _DMAADDRCLR       ( _SFRS_ADDR(1) + 0x3024)
#define  _DMAADDRSET       ( _SFRS_ADDR(1) + 0x3028)
#define  _DMAADDRINV       ( _SFRS_ADDR(1) + 0x302C)
#define  _DCRCCON          ( _SFRS_ADDR(1) + 0x3030)
#define  _DCRCCONCLR       ( _SFRS_ADDR(1) + 0x3034)
#define  _DCRCCONSET       ( _SFRS_ADDR(1) + 0x3038)
#define  _DCRCCONINV       ( _SFRS_ADDR(1) + 0x303C)
#define  _DCRCDATA         ( _SFRS_ADDR(1) + 0x3040)
#define  _DCRCDATACLR      ( _SFRS_ADDR(1) + 0x3044)
#define  _DCRCDATASET      ( _SFRS_ADDR(1) + 0x3048)
#define  _DCRCDATAINV      ( _SFRS_ADDR(1) + 0x304C)
#define  _DCRCXOR          ( _SFRS_ADDR(1) + 0x3050)
#define  _DCRCXORCLR       ( _SFRS_ADDR(1) + 0x3054)
#define  _DCRCXORSET       ( _SFRS_ADDR(1) + 0x3058)
#define  _DCRCXORINV       ( _SFRS_ADDR(1) + 0x305C)
#define  _DCH0CON          ( _SFRS_ADDR(1) + 0x3060)
#define  _DCH0CONCLR       ( _SFRS_ADDR(1) + 0x3064)
#define  _DCH0CONSET       ( _SFRS_ADDR(1) + 0x3068)
#define  _DCH0CONINV       ( _SFRS_ADDR(1) + 0x306C)
#define  _DCH0ECON         ( _SFRS_ADDR(1) + 0x3070)
#define  _DCH0ECONCLR      ( _SFRS_ADDR(1) + 0x3074)
#define  _DCH0ECONSET      ( _SFRS_ADDR(1) + 0x3078)
#define  _DCH0ECONINV      ( _SFRS_ADDR(1) + 0x307C)
#define  _DCH0INT          ( _SFRS_ADDR(1) + 0x3080)
#define  _DCH0INTCLR       ( _SFRS_ADDR(1) + 0x3084)
#define  _DCH0INTSET       ( _SFRS_ADDR(1) + 0x3088)
#define  _DCH0INTINV       ( _SFRS_ADDR(1) + 0x308C)
#define  _DCH0SSA          ( _SFRS_ADDR(1) + 0x3090)
#define  _DCH0SSACLR       ( _SFRS_ADDR(1) + 0x3094)
#define  _DCH0SSASET       ( _SFRS_ADDR(1) + 0x3098)
#define  _DCH0SSAINV       ( _SFRS_ADDR(1) + 0x309C)
#define  _DCH0DSA          ( _SFRS_ADDR(1) + 0x30A0)
#define  _DCH0DSACLR       ( _SFRS_ADDR(1) + 0x30A4)
#define  _DCH0DSASET       ( _SFRS_ADDR(1) + 0x30A8)
#define  _DCH0DSAINV       ( _SFRS_ADDR(1) + 0x30AC)
#define  _DCH0SSIZ         ( _SFRS_ADDR(1) + 0x30B0)
#define  _DCH0SSIZCLR      ( _SFRS_ADDR(1) + 0x30B4)
#define  _DCH0SSIZSET      ( _SFRS_ADDR(1) + 0x30B8)
#define  _DCH0SSIZINV      ( _SFRS_ADDR(1) + 0x30BC)
#define  _DCH0DSIZ         ( _SFRS_ADDR(1) + 0x30C0)
#define  _DCH0DSIZCLR      ( _SFRS_ADDR(1) + 0x30C4)
#define  _DCH0DSIZSET      ( _SFRS_ADDR(1) + 0x30C8)
#define  _DCH0DSIZINV      ( _SFRS_ADDR(1) + 0x30CC)
#define  _DCH0SPTR         ( _SFRS_ADDR(1) + 0x30D0)
#define  _DCH0SPTRCLR      ( _SFRS_ADDR(1) + 0x30D4)
#define  _DCH0SPTRSET      ( _SFRS_ADDR(1) + 0x30D8)
#define  _DCH0SPTRINV      ( _SFRS_ADDR(1) + 0x30DC)
#define  _DCH0DPTR         ( _SFRS_ADDR(1) + 0x30E0)
#define  _DCH0DPTRCLR      ( _SFRS_ADDR(1) + 0x30E4)
#define  _DCH0DPTRSET      ( _SFRS_ADDR(1) + 0x30E8)
#define  _DCH0DPTRINV      ( _SFRS_ADDR(1) + 0x30EC)
#define  _DCH0CSIZ         ( _SFRS_ADDR(1) + 0x30F0)
#define  _DCH0CSIZCLR      ( _SFRS_ADDR(1) + 0x30F4)
#define  _DCH0CSIZSET      ( _SFRS_ADDR(1) + 0x30F8)
#define  _DCH0CSIZINV      ( _SFRS_ADDR(1) + 0x30FC)
#define  _DCH0CPTR         ( _SFRS_ADDR(1) + 0x3100)
#define  _DCH0CPTRCLR      ( _SFRS_ADDR(1) + 0x3104)
#define  _DCH0CPTRSET      ( _SFRS_ADDR(1) + 0x3108)
#define  _DCH0CPTRINV      ( _SFRS_ADDR(1) + 0x310C)
#define  _DCH0DAT          ( _SFRS_ADDR(1) + 0x3110)
#define  _DCH0DATCLR       ( _SFRS_ADDR(1) + 0x3114)
#define  _DCH0DATSET       ( _SFRS_ADDR(1) + 0x3118)
#define  _DCH0DATINV       ( _SFRS_ADDR(1) + 0x311C)
#define  _DCH1CON          ( _SFRS_ADDR(1) + 0x3120)
#define  _DCH1CONCLR       ( _SFRS_ADDR(1) + 0x3124)
#define  _DCH1CONSET       ( _SFRS_ADDR(1) + 0x3128)
#define  _DCH1CONINV       ( _SFRS_ADDR(1) + 0x312C)
#define  _DCH1ECON         ( _SFRS_ADDR(1) + 0x3130)
#define  _DCH1ECONCLR      ( _SFRS_ADDR(1) + 0x3134)
#define  _DCH1ECONSET      ( _SFRS_ADDR(1) + 0x3138)
#define  _DCH1ECONINV      ( _SFRS_ADDR(1) + 0x313C)
#define  _DCH1INT          ( _SFRS_ADDR(1) + 0x3140)
#define  _DCH1INTCLR       ( _SFRS_ADDR(1) + 0x3144)
#define  _DCH1INTSET       ( _SFRS_ADDR(1) + 0x3148)
#define  _DCH1INTINV       ( _SFRS_ADDR(1) + 0x314C)
#define  _DCH1SSA          ( _SFRS_ADDR(1) + 0x3150)
#define  _DCH1SSACLR       ( _SFRS_ADDR(1) + 0x3154)
#define  _DCH1SSASET       ( _SFRS_ADDR(1) + 0x3158)
#define  _DCH1SSAINV       ( _SFRS_ADDR(1) + 0x315C)
#define  _DCH1DSA          ( _SFRS_ADDR(1) + 0x3160)
#define  _DCH1DSACLR       ( _SFRS_ADDR(1) + 0x3164)
#define  _DCH1DSASET       ( _SFRS_ADDR(1) + 0x3168)
#define  _DCH1DSAINV       ( _SFRS_ADDR(1) + 0x316C)
#define  _DCH1SSIZ         ( _SFRS_ADDR(1) + 0x3170)
#define  _DCH1SSIZCLR      ( _SFRS_ADDR(1) + 0x3174)
#define  _DCH1SSIZSET      ( _SFRS_ADDR(1) + 0x3178)
#define  _DCH1SSIZINV      ( _SFRS_ADDR(1) + 0x317C)
#define  _DCH1DSIZ         ( _SFRS_ADDR(1) + 0x3180)
#define  _DCH1DSIZCLR      ( _SFRS_ADDR(1) + 0x3184)
#define  _DCH1DSIZSET      ( _SFRS_ADDR(1) + 0x3188)
#define  _DCH1DSIZINV      ( _SFRS_ADDR(1) + 0x318C)
#define  _DCH1SPTR         ( _SFRS_ADDR(1) + 0x3190)
#define  _DCH1SPTRCLR      ( _SFRS_ADDR(1) + 0x3194)
#define  _DCH1SPTRSET      ( _SFRS_ADDR(1) + 0x3198)
#define  _DCH1SPTRINV      ( _SFRS_ADDR(1) + 0x319C)
#define  _DCH1DPTR         ( _SFRS_ADDR(1) + 0x31A0)
#define  _DCH1DPTRCLR      ( _SFRS_ADDR(1) + 0x31A4)
#define  _DCH1DPTRSET      ( _SFRS_ADDR(1) + 0x31A8)
#define  _DCH1DPTRINV      ( _SFRS_ADDR(1) + 0x31AC)
#define  _DCH1CSIZ         ( _SFRS_ADDR(1) + 0x31B0)
#define  _DCH1CSIZCLR      ( _SFRS_ADDR(1) + 0x31B4)
#define  _DCH1CSIZSET      ( _SFRS_ADDR(1) + 0x31B8)
#define  _DCH1CSIZINV      ( _SFRS_ADDR(1) + 0x31BC)
#define  _DCH1CPTR         ( _SFRS_ADDR(1) + 0x31C0)
#define  _DCH1CPTRCLR      ( _SFRS_ADDR(1) + 0x31C4)
#define  _DCH1CPTRSET      ( _SFRS_ADDR(1) + 0x31C8)
#define  _DCH1CPTRINV      ( _SFRS_ADDR(1) + 0x31CC)
#define  _DCH1DAT          ( _SFRS_ADDR(1) + 0x31D0)
#define  _DCH1DATCLR       ( _SFRS_ADDR(1) + 0x31D4)
#define  _DCH1DATSET       ( _SFRS_ADDR(1) + 0x31D8)
#define  _DCH1DATINV       ( _SFRS_ADDR(1) + 0x31DC)
#define  _DCH2CON          ( _SFRS_ADDR(1) + 0x31E0)
#define  _DCH2CONCLR       ( _SFRS_ADDR(1) + 0x31E4)
#define  _DCH2CONSET       ( _SFRS_ADDR(1) + 0x31E8)
#define  _DCH2CONINV       ( _SFRS_ADDR(1) + 0x31EC)
#define  _DCH2ECON         ( _SFRS_ADDR(1) + 0x31F0)
#define  _DCH2ECONCLR      ( _SFRS_ADDR(1) + 0x31F4)
#define  _DCH2ECONSET      ( _SFRS_ADDR(1) + 0x31F8)
#define  _DCH2ECONINV      ( _SFRS_ADDR(1) + 0x31FC)
#define  _DCH2INT          ( _SFRS_ADDR(1) + 0x3200)
#define  _DCH2INTCLR       ( _SFRS_ADDR(1) + 0x3204)
#define  _DCH2INTSET       ( _SFRS_ADDR(1) + 0x3208)
#define  _DCH2INTINV       ( _SFRS_ADDR(1) + 0x320C)
#define  _DCH2SSA          ( _SFRS_ADDR(1) + 0x3210)
#define  _DCH2SSACLR       ( _SFRS_ADDR(1) + 0x3214)
#define  _DCH2SSASET       ( _SFRS_ADDR(1) + 0x3218)
#define  _DCH2SSAINV       ( _SFRS_ADDR(1) + 0x321C)
#define  _DCH2DSA          ( _SFRS_ADDR(1) + 0x3220)
#define  _DCH2DSACLR       ( _SFRS_ADDR(1) + 0x3224)
#define  _DCH2DSASET       ( _SFRS_ADDR(1) + 0x3228)
#define  _DCH2DSAINV       ( _SFRS_ADDR(1) + 0x322C)
#define  _DCH2SSIZ         ( _SFRS_ADDR(1) + 0x3230)
#define  _DCH2SSIZCLR      ( _SFRS_ADDR(1) + 0x3234)
#define  _DCH2SSIZSET      ( _SFRS_ADDR(1) + 0x3238)
#define  _DCH2SSIZINV      ( _SFRS_ADDR(1) + 0x323C)
#define  _DCH2DSIZ         ( _SFRS_ADDR(1) + 0x3240)
#define  _DCH2DSIZCLR      ( _SFRS_ADDR(1) + 0x3244)
#define  _DCH2DSIZSET      ( _SFRS_ADDR(1) + 0x3248)
#define  _DCH2DSIZINV      ( _SFRS_ADDR(1) + 0x324C)
#define  _DCH2SPTR         ( _SFRS_ADDR(1) + 0x3250)
#define  _DCH2SPTRCLR      ( _SFRS_ADDR(1) + 0x3254)
#define  _DCH2SPTRSET      ( _SFRS_ADDR(1) + 0x3258)
#define  _DCH2SPTRINV      ( _SFRS_ADDR(1) + 0x325C)
#define  _DCH2DPTR         ( _SFRS_ADDR(1) + 0x3260)
#define  _DCH2DPTRCLR      ( _SFRS_ADDR(1) + 0x3264)
#define  _DCH2DPTRSET      ( _SFRS_ADDR(1) + 0x3268)
#define  _DCH2DPTRINV      ( _SFRS_ADDR(1) + 0x326C)
#define  _DCH2CSIZ         ( _SFRS_ADDR(1) + 0x3270)
#define  _DCH2CSIZCLR      ( _SFRS_ADDR(1) + 0x3274)
#define  _DCH2CSIZSET      ( _SFRS_ADDR(1) + 0x3278)
#define  _DCH2CSIZINV      ( _SFRS_ADDR(1) + 0x327C)
#define  _DCH2CPTR         ( _SFRS_ADDR(1) + 0x3280)
#define  _DCH2CPTRCLR      ( _SFRS_ADDR(1) + 0x3284)
#define  _DCH2CPTRSET      ( _SFRS_ADDR(1) + 0x3288)
#define  _DCH2CPTRINV      ( _SFRS_ADDR(1) + 0x328C)
#define  _DCH2DAT          ( _SFRS_ADDR(1) + 0x3290)
#define  _DCH2DATCLR       ( _SFRS_ADDR(1) + 0x3294)
#define  _DCH2DATSET       ( _SFRS_ADDR(1) + 0x3298)
#define  _DCH2DATINV       ( _SFRS_ADDR(1) + 0x329C)
#define  _DCH3CON          ( _SFRS_ADDR(1) + 0x32A0)
#define  _DCH3CONCLR       ( _SFRS_ADDR(1) + 0x32A4)
#define  _DCH3CONSET       ( _SFRS_ADDR(1) + 0x32A8)
#define  _DCH3CONINV       ( _SFRS_ADDR(1) + 0x32AC)
#define  _DCH3ECON         ( _SFRS_ADDR(1) + 0x32B0)
#define  _DCH3ECONCLR      ( _SFRS_ADDR(1) + 0x32B4)
#define  _DCH3ECONSET      ( _SFRS_ADDR(1) + 0x32B8)
#define  _DCH3ECONINV      ( _SFRS_ADDR(1) + 0x32BC)
#define  _DCH3INT          ( _SFRS_ADDR(1) + 0x32C0)
#define  _DCH3INTCLR       ( _SFRS_ADDR(1) + 0x32C4)
#define  _DCH3INTSET       ( _SFRS_ADDR(1) + 0x32C8)
#define  _DCH3INTINV       ( _SFRS_ADDR(1) + 0x32CC)
#define  _DCH3SSA          ( _SFRS_ADDR(1) + 0x32D0)
#define  _DCH3SSACLR       ( _SFRS_ADDR(1) + 0x32D4)
#define  _DCH3SSASET       ( _SFRS_ADDR(1) + 0x32D8)
#define  _DCH3SSAINV       ( _SFRS_ADDR(1) + 0x32DC)
#define  _DCH3DSA          ( _SFRS_ADDR(1) + 0x32E0)
#define  _DCH3DSACLR       ( _SFRS_ADDR(1) + 0x32E4)
#define  _DCH3DSASET       ( _SFRS_ADDR(1) + 0x32E8)
#define  _DCH3DSAINV       ( _SFRS_ADDR(1) + 0x32EC)
#define  _DCH3SSIZ         ( _SFRS_ADDR(1) + 0x32F0)
#define  _DCH3SSIZCLR      ( _SFRS_ADDR(1) + 0x32F4)
#define  _DCH3SSIZSET      ( _SFRS_ADDR(1) + 0x32F8)
#define  _DCH3SSIZINV      ( _SFRS_ADDR(1) + 0x32FC)
#define  _DCH3DSIZ         ( _SFRS_ADDR(1) + 0x3300)
#define  _DCH3DSIZCLR      ( _SFRS_ADDR(1) + 0x3304)
#define  _DCH3DSIZSET      ( _SFRS_ADDR(1) + 0x3308)
#define  _DCH3DSIZINV      ( _SFRS_ADDR(1) + 0x330C)
#define  _DCH3SPTR         ( _SFRS_ADDR(1) + 0x3310)
#define  _DCH3SPTRCLR      ( _SFRS_ADDR(1) + 0x3314)
#define  _DCH3SPTRSET      ( _SFRS_ADDR(1) + 0x3318)
#define  _DCH3SPTRINV      ( _SFRS_ADDR(1) + 0x331C)
#define  _DCH3DPTR         ( _SFRS_ADDR(1) + 0x3320)
#define  _DCH3DPTRCLR      ( _SFRS_ADDR(1) + 0x3324)
#define  _DCH3DPTRSET      ( _SFRS_ADDR(1) + 0x3328)
#define  _DCH3DPTRINV      ( _SFRS_ADDR(1) + 0x332C)
#define  _DCH3CSIZ         ( _SFRS_ADDR(1) + 0x3330)
#define  _DCH3CSIZCLR      ( _SFRS_ADDR(1) + 0x3334)
#define  _DCH3CSIZSET      ( _SFRS_ADDR(1) + 0x3338)
#define  _DCH3CSIZINV      ( _SFRS_ADDR(1) + 0x333C)
#define  _DCH3CPTR         ( _SFRS_ADDR(1) + 0x3340)
#define  _DCH3CPTRCLR      ( _SFRS_ADDR(1) + 0x3344)
#define  _DCH3CPTRSET      ( _SFRS_ADDR(1) + 0x3348)
#define  _DCH3CPTRINV      ( _SFRS_ADDR(1) + 0x334C)
#define  _DCH3DAT          ( _SFRS_ADDR(1) + 0x3350)
#define  _DCH3DATCLR       ( _SFRS_ADDR(1) + 0x3354)
#define  _DCH3DATSET       ( _SFRS_ADDR(1) + 0x3358)
#define  _DCH3DATINV       ( _SFRS_ADDR(1) + 0x335C)
#define  _CHECON           ( _SFRS_ADDR(1) + 0x4000)
#define  _CHECONCLR        ( _SFRS_ADDR(1) + 0x4004)
#define  _CHECONSET        ( _SFRS_ADDR(1) + 0x4008)
#define  _CHECONINV        ( _SFRS_ADDR(1) + 0x400C)
#define  _CHEACC           ( _SFRS_ADDR(1) + 0x4010)
#define  _CHEACCCLR        ( _SFRS_ADDR(1) + 0x4014)
#define  _CHEACCSET        ( _SFRS_ADDR(1) + 0x4018)
#define  _CHEACCINV        ( _SFRS_ADDR(1) + 0x401C)
#define  _CHETAG           ( _SFRS_ADDR(1) + 0x4020)
#define  _CHETAGCLR        ( _SFRS_ADDR(1) + 0x4024)
#define  _CHETAGSET        ( _SFRS_ADDR(1) + 0x4028)
#define  _CHETAGINV        ( _SFRS_ADDR(1) + 0x402C)
#define  _CHEMSK           ( _SFRS_ADDR(1) + 0x4030)
#define  _CHEMSKCLR        ( _SFRS_ADDR(1) + 0x4034)
#define  _CHEMSKSET        ( _SFRS_ADDR(1) + 0x4038)
#define  _CHEMSKINV        ( _SFRS_ADDR(1) + 0x403C)
#define  _CHEW0            ( _SFRS_ADDR(1) + 0x4040)
#define  _CHEW1            ( _SFRS_ADDR(1) + 0x4050)
#define  _CHEW2            ( _SFRS_ADDR(1) + 0x4060)
#define  _CHEW3            ( _SFRS_ADDR(1) + 0x4070)
#define  _CHELRU           ( _SFRS_ADDR(1) + 0x4080)
#define  _CHEHIT           ( _SFRS_ADDR(1) + 0x4090)
#define  _CHEMIS           ( _SFRS_ADDR(1) + 0x40A0)
#define  _CHEPFABT         ( _SFRS_ADDR(1) + 0x40C0)
#define  _U1OTGIR          ( _SFRS_ADDR(1) + 0x5040)
#define  _U1OTGIRCLR       ( _SFRS_ADDR(1) + 0x5044)
#define  _U1OTGIE          ( _SFRS_ADDR(1) + 0x5050)
#define  _U1OTGIECLR       ( _SFRS_ADDR(1) + 0x5054)
#define  _U1OTGIESET       ( _SFRS_ADDR(1) + 0x5058)
#define  _U1OTGIEINV       ( _SFRS_ADDR(1) + 0x505C)
#define  _U1OTGSTAT        ( _SFRS_ADDR(1) + 0x5060)
#define  _U1OTGSTATCLR     ( _SFRS_ADDR(1) + 0x5064)
#define  _U1OTGCON         ( _SFRS_ADDR(1) + 0x5070)
#define  _U1OTGCONCLR      ( _SFRS_ADDR(1) + 0x5074)
#define  _U1OTGCONSET      ( _SFRS_ADDR(1) + 0x5078)
#define  _U1OTGCONINV      ( _SFRS_ADDR(1) + 0x507C)
#define  _U1PWRC           ( _SFRS_ADDR(1) + 0x5080)
#define  _U1PWRCCLR        ( _SFRS_ADDR(1) + 0x5084)
#define  _U1PWRCSET        ( _SFRS_ADDR(1) + 0x5088)
#define  _U1PWRCINV        ( _SFRS_ADDR(1) + 0x508C)
#define  _U1IR             ( _SFRS_ADDR(1) + 0x5200)
#define  _U1IRCLR          ( _SFRS_ADDR(1) + 0x5204)
#define  _U1IE             ( _SFRS_ADDR(1) + 0x5210)
#define  _U1IECLR          ( _SFRS_ADDR(1) + 0x5214)
#define  _U1IESET          ( _SFRS_ADDR(1) + 0x5218)
#define  _U1IEINV          ( _SFRS_ADDR(1) + 0x521C)
#define  _U1EIR            ( _SFRS_ADDR(1) + 0x5220)
#define  _U1EIRCLR         ( _SFRS_ADDR(1) + 0x5224)
#define  _U1EIE            ( _SFRS_ADDR(1) + 0x5230)
#define  _U1EIECLR         ( _SFRS_ADDR(1) + 0x5234)
#define  _U1EIESET         ( _SFRS_ADDR(1) + 0x5238)
#define  _U1EIEINV         ( _SFRS_ADDR(1) + 0x523C)
#define  _U1STAT           ( _SFRS_ADDR(1) + 0x5240)
#define  _U1STATCLR        ( _SFRS_ADDR(1) + 0x5244)
#define  _U1STATSET        ( _SFRS_ADDR(1) + 0x5248)
#define  _U1STATINV        ( _SFRS_ADDR(1) + 0x524C)
#define  _U1CON            ( _SFRS_ADDR(1) + 0x5250)
#define  _U1CONCLR         ( _SFRS_ADDR(1) + 0x5254)
#define  _U1CONSET         ( _SFRS_ADDR(1) + 0x5258)
#define  _U1CONINV         ( _SFRS_ADDR(1) + 0x525C)
#define  _U1ADDR           ( _SFRS_ADDR(1) + 0x5260)
#define  _U1ADDRCLR        ( _SFRS_ADDR(1) + 0x5264)
#define  _U1ADDRSET        ( _SFRS_ADDR(1) + 0x5268)
#define  _U1ADDRINV        ( _SFRS_ADDR(1) + 0x526C)
#define  _U1BDTP1          ( _SFRS_ADDR(1) + 0x5270)
#define  _U1BDTP1CLR       ( _SFRS_ADDR(1) + 0x5274)
#define  _U1BDTP1SET       ( _SFRS_ADDR(1) + 0x5278)
#define  _U1BDTP1INV       ( _SFRS_ADDR(1) + 0x527C)
#define  _U1FRML           ( _SFRS_ADDR(1) + 0x5280)
#define  _U1FRMLCLR        ( _SFRS_ADDR(1) + 0x5284)
#define  _U1FRMLSET        ( _SFRS_ADDR(1) + 0x5288)
#define  _U1FRMLINV        ( _SFRS_ADDR(1) + 0x528C)
#define  _U1FRMH           ( _SFRS_ADDR(1) + 0x5290)
#define  _U1FRMHCLR        ( _SFRS_ADDR(1) + 0x5294)
#define  _U1FRMHSET        ( _SFRS_ADDR(1) + 0x5298)
#define  _U1FRMHINV        ( _SFRS_ADDR(1) + 0x529C)
#define  _U1TOK            ( _SFRS_ADDR(1) + 0x52A0)
#define  _U1TOKCLR         ( _SFRS_ADDR(1) + 0x52A4)
#define  _U1TOKSET         ( _SFRS_ADDR(1) + 0x52A8)
#define  _U1TOKINV         ( _SFRS_ADDR(1) + 0x52AC)
#define  _U1SOF            ( _SFRS_ADDR(1) + 0x52B0)
#define  _U1SOFCLR         ( _SFRS_ADDR(1) + 0x52B4)
#define  _U1SOFSET         ( _SFRS_ADDR(1) + 0x52B8)
#define  _U1SOFINV         ( _SFRS_ADDR(1) + 0x52BC)
#define  _U1BDTP2          ( _SFRS_ADDR(1) + 0x52C0)
#define  _U1BDTP2CLR       ( _SFRS_ADDR(1) + 0x52C4)
#define  _U1BDTP2SET       ( _SFRS_ADDR(1) + 0x52C8)
#define  _U1BDTP2INV       ( _SFRS_ADDR(1) + 0x52CC)
#define  _U1BDTP3          ( _SFRS_ADDR(1) + 0x52D0)
#define  _U1BDTP3CLR       ( _SFRS_ADDR(1) + 0x52D4)
#define  _U1BDTP3SET       ( _SFRS_ADDR(1) + 0x52D8)
#define  _U1BDTP3INV       ( _SFRS_ADDR(1) + 0x52DC)
#define  _U1CNFG1          ( _SFRS_ADDR(1) + 0x52E0)
#define  _U1CNFG1CLR       ( _SFRS_ADDR(1) + 0x52E4)
#define  _U1CNFG1SET       ( _SFRS_ADDR(1) + 0x52E8)
#define  _U1CNFG1INV       ( _SFRS_ADDR(1) + 0x52EC)
#define  _U1EP0            ( _SFRS_ADDR(1) + 0x5300)
#define  _U1EP0CLR         ( _SFRS_ADDR(1) + 0x5304)
#define  _U1EP0SET         ( _SFRS_ADDR(1) + 0x5308)
#define  _U1EP0INV         ( _SFRS_ADDR(1) + 0x530C)
#define  _U1EP1            ( _SFRS_ADDR(1) + 0x5310)
#define  _U1EP1CLR         ( _SFRS_ADDR(1) + 0x5314)
#define  _U1EP1SET         ( _SFRS_ADDR(1) + 0x5318)
#define  _U1EP1INV         ( _SFRS_ADDR(1) + 0x531C)
#define  _U1EP2            ( _SFRS_ADDR(1) + 0x5320)
#define  _U1EP2CLR         ( _SFRS_ADDR(1) + 0x5324)
#define  _U1EP2SET         ( _SFRS_ADDR(1) + 0x5328)
#define  _U1EP2INV         ( _SFRS_ADDR(1) + 0x532C)
#define  _U1EP3            ( _SFRS_ADDR(1) + 0x5330)
#define  _U1EP3CLR         ( _SFRS_ADDR(1) + 0x5334)
#define  _U1EP3SET         ( _SFRS_ADDR(1) + 0x5338)
#define  _U1EP3INV         ( _SFRS_ADDR(1) + 0x533C)
#define  _U1EP4            ( _SFRS_ADDR(1) + 0x5340)
#define  _U1EP4CLR         ( _SFRS_ADDR(1) + 0x5344)
#define  _U1EP4SET         ( _SFRS_ADDR(1) + 0x5348)
#define  _U1EP4INV         ( _SFRS_ADDR(1) + 0x534C)
#define  _U1EP5            ( _SFRS_ADDR(1) + 0x5350)
#define  _U1EP5CLR         ( _SFRS_ADDR(1) + 0x5354)
#define  _U1EP5SET         ( _SFRS_ADDR(1) + 0x5358)
#define  _U1EP5INV         ( _SFRS_ADDR(1) + 0x535C)
#define  _U1EP6            ( _SFRS_ADDR(1) + 0x5360)
#define  _U1EP6CLR         ( _SFRS_ADDR(1) + 0x5364)
#define  _U1EP6SET         ( _SFRS_ADDR(1) + 0x5368)
#define  _U1EP6INV         ( _SFRS_ADDR(1) + 0x536C)
#define  _U1EP7            ( _SFRS_ADDR(1) + 0x5370)
#define  _U1EP7CLR         ( _SFRS_ADDR(1) + 0x5374)
#define  _U1EP7SET         ( _SFRS_ADDR(1) + 0x5378)
#define  _U1EP7INV         ( _SFRS_ADDR(1) + 0x537C)
#define  _U1EP8            ( _SFRS_ADDR(1) + 0x5380)
#define  _U1EP8CLR         ( _SFRS_ADDR(1) + 0x5384)
#define  _U1EP8SET         ( _SFRS_ADDR(1) + 0x5388)
#define  _U1EP8INV         ( _SFRS_ADDR(1) + 0x538C)
#define  _U1EP9            ( _SFRS_ADDR(1) + 0x5390)
#define  _U1EP9CLR         ( _SFRS_ADDR(1) + 0x5394)
#define  _U1EP9SET         ( _SFRS_ADDR(1) + 0x5398)
#define  _U1EP9INV         ( _SFRS_ADDR(1) + 0x539C)
#define  _U1EP10           ( _SFRS_ADDR(1) + 0x53A0)
#define  _U1EP10CLR        ( _SFRS_ADDR(1) + 0x53A4)
#define  _U1EP10SET        ( _SFRS_ADDR(1) + 0x53A8)
#define  _U1EP10INV        ( _SFRS_ADDR(1) + 0x53AC)
#define  _U1EP11           ( _SFRS_ADDR(1) + 0x53B0)
#define  _U1EP11CLR        ( _SFRS_ADDR(1) + 0x53B4)
#define  _U1EP11SET        ( _SFRS_ADDR(1) + 0x53B8)
#define  _U1EP11INV        ( _SFRS_ADDR(1) + 0x53BC)
#define  _U1EP12           ( _SFRS_ADDR(1) + 0x53C0)
#define  _U1EP12CLR        ( _SFRS_ADDR(1) + 0x53C4)
#define  _U1EP12SET        ( _SFRS_ADDR(1) + 0x53C8)
#define  _U1EP12INV        ( _SFRS_ADDR(1) + 0x53CC)
#define  _U1EP13           ( _SFRS_ADDR(1) + 0x53D0)
#define  _U1EP13CLR        ( _SFRS_ADDR(1) + 0x53D4)
#define  _U1EP13SET        ( _SFRS_ADDR(1) + 0x53D8)
#define  _U1EP13INV        ( _SFRS_ADDR(1) + 0x53DC)
#define  _U1EP14           ( _SFRS_ADDR(1) + 0x53E0)
#define  _U1EP14CLR        ( _SFRS_ADDR(1) + 0x53E4)
#define  _U1EP14SET        ( _SFRS_ADDR(1) + 0x53E8)
#define  _U1EP14INV        ( _SFRS_ADDR(1) + 0x53EC)
#define  _U1EP15           ( _SFRS_ADDR(1) + 0x53F0)
#define  _U1EP15CLR        ( _SFRS_ADDR(1) + 0x53F4)
#define  _U1EP15SET        ( _SFRS_ADDR(1) + 0x53F8)
#define  _U1EP15INV        ( _SFRS_ADDR(1) + 0x53FC)
#define  _TRISA            ( _SFRS_ADDR(1) + 0x6000)
#define  _TRISACLR         ( _SFRS_ADDR(1) + 0x6004)
#define  _TRISASET         ( _SFRS_ADDR(1) + 0x6008)
#define  _TRISAINV         ( _SFRS_ADDR(1) + 0x600C)
#define  _PORTA            ( _SFRS_ADDR(1) + 0x6010)
#define  _PORTACLR         ( _SFRS_ADDR(1) + 0x6014)
#define  _PORTASET         ( _SFRS_ADDR(1) + 0x6018)
#define  _PORTAINV         ( _SFRS_ADDR(1) + 0x601C)
#define  _LATA             ( _SFRS_ADDR(1) + 0x6020)
#define  _LATACLR          ( _SFRS_ADDR(1) + 0x6024)
#define  _LATASET          ( _SFRS_ADDR(1) + 0x6028)
#define  _LATAINV          ( _SFRS_ADDR(1) + 0x602C)
#define  _ODCA             ( _SFRS_ADDR(1) + 0x6030)
#define  _ODCACLR          ( _SFRS_ADDR(1) + 0x6034)
#define  _ODCASET          ( _SFRS_ADDR(1) + 0x6038)
#define  _ODCAINV          ( _SFRS_ADDR(1) + 0x603C)
#define  _TRISB            ( _SFRS_ADDR(1) + 0x6040)
#define  _TRISBCLR         ( _SFRS_ADDR(1) + 0x6044)
#define  _TRISBSET         ( _SFRS_ADDR(1) + 0x6048)
#define  _TRISBINV         ( _SFRS_ADDR(1) + 0x604C)
#define  _PORTB            ( _SFRS_ADDR(1) + 0x6050)
#define  _PORTBCLR         ( _SFRS_ADDR(1) + 0x6054)
#define  _PORTBSET         ( _SFRS_ADDR(1) + 0x6058)
#define  _PORTBINV         ( _SFRS_ADDR(1) + 0x605C)
#define  _LATB             ( _SFRS_ADDR(1) + 0x6060)
#define  _LATBCLR          ( _SFRS_ADDR(1) + 0x6064)
#define  _LATBSET          ( _SFRS_ADDR(1) + 0x6068)
#define  _LATBINV          ( _SFRS_ADDR(1) + 0x606C)
#define  _ODCB             ( _SFRS_ADDR(1) + 0x6070)
#define  _ODCBCLR          ( _SFRS_ADDR(1) + 0x6074)
#define  _ODCBSET          ( _SFRS_ADDR(1) + 0x6078)
#define  _ODCBINV          ( _SFRS_ADDR(1) + 0x607C)
#define  _TRISC            ( _SFRS_ADDR(1) + 0x6080)
#define  _TRISCCLR         ( _SFRS_ADDR(1) + 0x6084)
#define  _TRISCSET         ( _SFRS_ADDR(1) + 0x6088)
#define  _TRISCINV         ( _SFRS_ADDR(1) + 0x608C)
#define  _PORTC            ( _SFRS_ADDR(1) + 0x6090)
#define  _PORTCCLR         ( _SFRS_ADDR(1) + 0x6094)
#define  _PORTCSET         ( _SFRS_ADDR(1) + 0x6098)
#define  _PORTCINV         ( _SFRS_ADDR(1) + 0x609C)
#define  _LATC             ( _SFRS_ADDR(1) + 0x60A0)
#define  _LATCCLR          ( _SFRS_ADDR(1) + 0x60A4)
#define  _LATCSET          ( _SFRS_ADDR(1) + 0x60A8)
#define  _LATCINV          ( _SFRS_ADDR(1) + 0x60AC)
#define  _ODCC             ( _SFRS_ADDR(1) + 0x60B0)
#define  _ODCCCLR          ( _SFRS_ADDR(1) + 0x60B4)
#define  _ODCCSET          ( _SFRS_ADDR(1) + 0x60B8)
#define  _ODCCINV          ( _SFRS_ADDR(1) + 0x60BC)
#define  _TRISD            ( _SFRS_ADDR(1) + 0x60C0)
#define  _TRISDCLR         ( _SFRS_ADDR(1) + 0x60C4)
#define  _TRISDSET         ( _SFRS_ADDR(1) + 0x60C8)
#define  _TRISDINV         ( _SFRS_ADDR(1) + 0x60CC)
#define  _PORTD            ( _SFRS_ADDR(1) + 0x60D0)
#define  _PORTDCLR         ( _SFRS_ADDR(1) + 0x60D4)
#define  _PORTDSET         ( _SFRS_ADDR(1) + 0x60D8)
#define  _PORTDINV         ( _SFRS_ADDR(1) + 0x60DC)
#define  _LATD             ( _SFRS_ADDR(1) + 0x60E0)
#define  _LATDCLR          ( _SFRS_ADDR(1) + 0x60E4)
#define  _LATDSET          ( _SFRS_ADDR(1) + 0x60E8)
#define  _LATDINV          ( _SFRS_ADDR(1) + 0x60EC)
#define  _ODCD             ( _SFRS_ADDR(1) + 0x60F0)
#define  _ODCDCLR          ( _SFRS_ADDR(1) + 0x60F4)
#define  _ODCDSET          ( _SFRS_ADDR(1) + 0x60F8)
#define  _ODCDINV          ( _SFRS_ADDR(1) + 0x60FC)
#define  _TRISE            ( _SFRS_ADDR(1) + 0x6100)
#define  _TRISECLR         ( _SFRS_ADDR(1) + 0x6104)
#define  _TRISESET         ( _SFRS_ADDR(1) + 0x6108)
#define  _TRISEINV         ( _SFRS_ADDR(1) + 0x610C)
#define  _PORTE            ( _SFRS_ADDR(1) + 0x6110)
#define  _PORTECLR         ( _SFRS_ADDR(1) + 0x6114)
#define  _PORTESET         ( _SFRS_ADDR(1) + 0x6118)
#define  _PORTEINV         ( _SFRS_ADDR(1) + 0x611C)
#define  _LATE             ( _SFRS_ADDR(1) + 0x6120)
#define  _LATECLR          ( _SFRS_ADDR(1) + 0x6124)
#define  _LATESET          ( _SFRS_ADDR(1) + 0x6128)
#define  _LATEINV          ( _SFRS_ADDR(1) + 0x612C)
#define  _ODCE             ( _SFRS_ADDR(1) + 0x6130)
#define  _ODCECLR          ( _SFRS_ADDR(1) + 0x6134)
#define  _ODCESET          ( _SFRS_ADDR(1) + 0x6138)
#define  _ODCEINV          ( _SFRS_ADDR(1) + 0x613C)
#define  _TRISF            ( _SFRS_ADDR(1) + 0x6140)
#define  _TRISFCLR         ( _SFRS_ADDR(1) + 0x6144)
#define  _TRISFSET         ( _SFRS_ADDR(1) + 0x6148)
#define  _TRISFINV         ( _SFRS_ADDR(1) + 0x614C)
#define  _PORTF            ( _SFRS_ADDR(1) + 0x6150)
#define  _PORTFCLR         ( _SFRS_ADDR(1) + 0x6154)
#define  _PORTFSET         ( _SFRS_ADDR(1) + 0x6158)
#define  _PORTFINV         ( _SFRS_ADDR(1) + 0x615C)
#define  _LATF             ( _SFRS_ADDR(1) + 0x6160)
#define  _LATFCLR          ( _SFRS_ADDR(1) + 0x6164)
#define  _LATFSET          ( _SFRS_ADDR(1) + 0x6168)
#define  _LATFINV          ( _SFRS_ADDR(1) + 0x616C)
#define  _ODCF             ( _SFRS_ADDR(1) + 0x6170)
#define  _ODCFCLR          ( _SFRS_ADDR(1) + 0x6174)
#define  _ODCFSET          ( _SFRS_ADDR(1) + 0x6178)
#define  _ODCFINV          ( _SFRS_ADDR(1) + 0x617C)
#define  _TRISG            ( _SFRS_ADDR(1) + 0x6180)
#define  _TRISGCLR         ( _SFRS_ADDR(1) + 0x6184)
#define  _TRISGSET         ( _SFRS_ADDR(1) + 0x6188)
#define  _TRISGINV         ( _SFRS_ADDR(1) + 0x618C)
#define  _PORTG            ( _SFRS_ADDR(1) + 0x6190)
#define  _PORTGCLR         ( _SFRS_ADDR(1) + 0x6194)
#define  _PORTGSET         ( _SFRS_ADDR(1) + 0x6198)
#define  _PORTGINV         ( _SFRS_ADDR(1) + 0x619C)
#define  _LATG             ( _SFRS_ADDR(1) + 0x61A0)
#define  _LATGCLR          ( _SFRS_ADDR(1) + 0x61A4)
#define  _LATGSET          ( _SFRS_ADDR(1) + 0x61A8)
#define  _LATGINV          ( _SFRS_ADDR(1) + 0x61AC)
#define  _ODCG             ( _SFRS_ADDR(1) + 0x61B0)
#define  _ODCGCLR          ( _SFRS_ADDR(1) + 0x61B4)
#define  _ODCGSET          ( _SFRS_ADDR(1) + 0x61B8)
#define  _ODCGINV          ( _SFRS_ADDR(1) + 0x61BC)
#define  _CNCON            ( _SFRS_ADDR(1) + 0x61C0)
#define  _CNCONCLR         ( _SFRS_ADDR(1) + 0x61C4)
#define  _CNCONSET         ( _SFRS_ADDR(1) + 0x61C8)
#define  _CNCONINV         ( _SFRS_ADDR(1) + 0x61CC)
#define  _CNEN             ( _SFRS_ADDR(1) + 0x61D0)
#define  _CNENCLR          ( _SFRS_ADDR(1) + 0x61D4)
#define  _CNENSET          ( _SFRS_ADDR(1) + 0x61D8)
#define  _CNENINV          ( _SFRS_ADDR(1) + 0x61DC)
#define  _CNPUE            ( _SFRS_ADDR(1) + 0x61E0)
#define  _CNPUECLR         ( _SFRS_ADDR(1) + 0x61E4)
#define  _CNPUESET         ( _SFRS_ADDR(1) + 0x61E8)
#define  _CNPUEINV         ( _SFRS_ADDR(1) + 0x61EC)

#define  _DEVCFG3          0xBFC02FF0
#define  _DEVCFG2          0xBFC02FF4
#define  _DEVCFG1          0xBFC02FF8
#define  _DEVCFG0          0xBFC02FFC
#endif
