#ifndef _JZ_P32MX_CAPT_H_
#define _JZ_P32MX_CAPT_H_
#include <stdint.h>

/* input/output capture */
  /* x=0: IC1 .. x=4: IC5 */
  #define IC_CON(x)        (*(volatile uint16_t *)(0xBF802000 + (x)*0x200))
  #define IC_CON_CLR       (*(volatile uint16_t *)(0xBF802004 + (x)*0x200))
  #define IC_CON_SET       (*(volatile uint16_t *)(0xBF802008 + (x)*0x200))
  #define IC_CON_INV       (*(volatile uint16_t *)(0xBF80200C + (x)*0x200))
  #define IC_BUF           (*(volatile uint32_t *)(0xBF802010 + (x)*0x200))

  /* x=0: OC1 .. x=4: OC5 */
  #define OC_CON(x)           (*(volatile uint16_t *)(0xBF803000 + (x)*0x200))
  #define OC_CON_CLR(x)       (*(volatile uint16_t *)(0xBF803004 + (x)*0x200))
  #define OC_CON_SET(x)       (*(volatile uint16_t *)(0xBF803008 + (x)*0x200))
  #define OC_CON_INV(x)       (*(volatile uint16_t *)(0xBF80300C + (x)*0x200))
  #define OC_R(x)             (*(volatile uint32_t *)(0xBF803010 + (x)*0x200))
  #define OC_R_CLR(x)         (*(volatile uint32_t *)(0xBF803014 + (x)*0x200))
  #define OC_R_SET(x)         (*(volatile uint32_t *)(0xBF803018 + (x)*0x200))
  #define OC_R_INV(x)         (*(volatile uint32_t *)(0xBF80301C + (x)*0x200))
  #define OC_RS(x)            (*(volatile uint32_t *)(0xBF803020 + (x)*0x200))
  #define OC_RS_CLR(x)        (*(volatile uint32_t *)(0xBF803024 + (x)*0x200))
  #define OC_RS_SET(x)        (*(volatile uint32_t *)(0xBF803028 + (x)*0x200))
  #define OC_RS_INV(x)        (*(volatile uint32_t *)(0xBF80302C + (x)*0x200))

    #define IC_CON_ICM                     0x00
    #define IC_CON_ICBNE                   0x03
    #define IC_CON_ICOV                    0x04
    #define IC_CON_ICI                     0x05
    #define IC_CON_ICTMR                   0x07
    #define IC_CON_C32                     0x08
    #define IC_CON_FEDGE                   0x09
    #define IC_CON_SIDL                    0x0D
    #define IC_CON_ON                      0x0F

    #define IC_CON_ICM0                    0x00
    #define IC_CON_ICM1                    0x01
    #define IC_CON_ICM2                    0x02
    #define IC_CON_ICI0                    0x05
    #define IC_CON_ICI1                    0x06
    #define IC_CON_ICSIDL                  0x0D

    #define OC_CON_OCM                     0x00
    #define OC_CON_OCTSEL                  0x03
    #define OC_CON_OCFLT                   0x04
    #define OC_CON_OC32                    0x05
    #define OC_CON_SIDL                    0x0D
    #define OC_CON_ON                      0x0F

    #define OC_CON_OCM0                    0x00
    #define OC_CON_OCM1                    0x01
    #define OC_CON_OCM2                    0x02
    #define OC_CON_OCSIDL                  0x0D
#endif /* _JZ_P32MX_CAPT_H_ */
