#ifndef _JZ_P32MX_DMAC_H_
#define _JZ_P32MX_DMAC_H_
#include <stdint.h>

#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_1;
  #define _dmac_base_addr        (_sfrs_base_addr_1 + 0x3000)
#else
  #define _dmac_base_addr	((const void *)0xBF883000)
#endif

/* 1xx/2xx/3xx/4xx DCH : 0..3 */
/* 5xx/6xx/7xx     DCH : 0..7 */

#define _DMAC_ADDR	 (_dmac_base_addr)
#define _DMAC_CH_ADDR(x) (_dmac_base_addr + 0x60 + (x)*0xc0)

  #define DMACON           (*(volatile uint32_t *)(_DMAC_ADDR + 0x00))
  #define DMACON_CLR       (*(volatile uint32_t *)(_DMAC_ADDR + 0x04))
  #define DMACON_SET       (*(volatile uint32_t *)(_DMAC_ADDR + 0x08))
  #define DMACON_INV       (*(volatile uint32_t *)(_DMAC_ADDR + 0x0C))
  #define DMASTAT          (*(volatile uint32_t *)(_DMAC_ADDR + 0x10))
  #define DMASTAT_CLR      (*(volatile uint32_t *)(_DMAC_ADDR + 0x14))
  #define DMASTAT_SET      (*(volatile uint32_t *)(_DMAC_ADDR + 0x18))
  #define DMASTAT_INV      (*(volatile uint32_t *)(_DMAC_ADDR + 0x1C))
  #define DMAADDR          (*(volatile uint32_t *)(_DMAC_ADDR + 0x20))
  #define DMAADDR_CLR      (*(volatile uint32_t *)(_DMAC_ADDR + 0x24))
  #define DMAADDR_SET      (*(volatile uint32_t *)(_DMAC_ADDR + 0x28))
  #define DMAADDR_INV      (*(volatile uint32_t *)(_DMAC_ADDR + 0x2C))
  #define DCRCCON          (*(volatile uint32_t *)(_DMAC_ADDR + 0x30))
  #define DCRCCON_CLR      (*(volatile uint32_t *)(_DMAC_ADDR + 0x34))
  #define DCRCCON_SET      (*(volatile uint32_t *)(_DMAC_ADDR + 0x38))
  #define DCRCCON_INV      (*(volatile uint32_t *)(_DMAC_ADDR + 0x3C))
  #define DCRCDATA         (*(volatile uint32_t *)(_DMAC_ADDR + 0x40))
  #define DCRCDATA_CLR     (*(volatile uint32_t *)(_DMAC_ADDR + 0x44))
  #define DCRCDATA_SET     (*(volatile uint32_t *)(_DMAC_ADDR + 0x48))
  #define DCRCDATA_INV     (*(volatile uint32_t *)(_DMAC_ADDR + 0x4C))
  #define DCRCXOR          (*(volatile uint32_t *)(_DMAC_ADDR + 0x50))
  #define DCRCXOR_CLR      (*(volatile uint32_t *)(_DMAC_ADDR + 0x54))
  #define DCRCXOR_SET      (*(volatile uint32_t *)(_DMAC_ADDR + 0x58))
  #define DCRCXOR_INV      (*(volatile uint32_t *)(_DMAC_ADDR + 0x5C))

  #define DCH_CON(x)          (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x00))
  #define DCH_CON_CLR(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x04))
  #define DCH_CON_SET(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x08))
  #define DCH_CON_INV(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x0C))
  #define DCH_ECON(x)         (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x10))
  #define DCH_ECON_CLR(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x14))
  #define DCH_ECON_SET(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x18))
  #define DCH_ECON_INV(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x1C))
  #define DCH_INT(x)          (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x20))
  #define DCH_INT_CLR(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x24))
  #define DCH_INT_SET(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x28))
  #define DCH_INT_INV(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x2C))
  #define DCH_SSA(x)          (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x30))
  #define DCH_SSA_CLR(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x34))
  #define DCH_SSA_SET(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x38))
  #define DCH_SSA_INV(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x3C))
  #define DCH_DSA(x)          (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x40))
  #define DCH_DSA_CLR(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x44))
  #define DCH_DSA_SET(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x48))
  #define DCH_DSA_INV(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x4C))
  #define DCH_SSIZ(x)         (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x50))
  #define DCH_SSIZ_CLR(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x54))
  #define DCH_SSIZ_SET(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x58))
  #define DCH_SSIZ_INV(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x5C))
  #define DCH_DSIZ(x)         (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x60))
  #define DCH_DSIZ_CLR(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x64))
  #define DCH_DSIZ_SET(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x68))
  #define DCH_DSIZ_INV(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x6C))
  #define DCH_SPTR(x)         (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x70))
  #define DCH_SPTR_CLR(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x74))
  #define DCH_SPTR_SET(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x78))
  #define DCH_SPTR_INV(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x7C))
  #define DCH_DPTR(x)         (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x80))
  #define DCH_DPTR_CLR(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x84))
  #define DCH_DPTR_SET(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x88))
  #define DCH_DPTR_INV(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x8C))
  #define DCH_CSIZ(x)         (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x90))
  #define DCH_CSIZ_CLR(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x94))
  #define DCH_CSIZ_SET(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x98))
  #define DCH_CSIZ_INV(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0x9C))
  #define DCH_CPTR(x)         (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xA0))
  #define DCH_CPTR_CLR(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xA4))
  #define DCH_CPTR_SET(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xA8))
  #define DCH_CPTR_INV(x)     (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xAC))
  #define DCH_DAT(x)          (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xB0))
  #define DCH_DAT_CLR(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xB4))
  #define DCH_DAT_SET(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xB8))
  #define DCH_DAT_INV(x)      (*(volatile uint32_t *)(_DMAC_CH_ADDR(x) + 0xBC))

    #define DMACON_DMABUSY                 0x0B
    #define DMACON_SUSPEND                 0x0C
    #define DMACON_ON                      0x0F
    #define DMASTAT_DMACH                  0x00
    #define DMASTAT_RDWR                   0x03

    #define DCRCCON_CRCCH                  0x00
    #define DCRCCON_CRCTYP                 0x05
    #define DCRCCON_CRCAPP                 0x06
    #define DCRCCON_CRCEN                  0x07
    #define DCRCCON_PLEN                   0x08
    #define DCRCCON_BITO                   0x18
    #define DCRCCON_WBO                    0x1B
    #define DCRCCON_BYTO                   0x1C

    #define DCH_CON_CHPRI                  0x00
    #define DCH_CON_CHEDET                 0x02
    #define DCH_CON_CHAEN                  0x04
    #define DCH_CON_CHCHN                  0x05
    #define DCH_CON_CHAED                  0x06
    #define DCH_CON_CHEN                   0x07
    #define DCH_CON_CHCHNS                 0x08
    #define DCH_CON_CHBUSY                 0x0F
    #define DCH_ECON_AIRQEN                0x03
    #define DCH_ECON_SIRQEN                0x04
    #define DCH_ECON_PATEN                 0x05
    #define DCH_ECON_CABORT                0x06
    #define DCH_ECON_CFORCE                0x07
    #define DCH_ECON_CHSIRQ                0x08
    #define DCH_ECON_CHAIRQ                0x10
    #define DCH_INT_CHERIF                 0x00
    #define DCH_INT_CHTAIF                 0x01
    #define DCH_INT_CHCCIF                 0x02
    #define DCH_INT_CHBCIF                 0x03
    #define DCH_INT_CHDHIF                 0x04
    #define DCH_INT_CHDDIF                 0x05
    #define DCH_INT_CHSHIF                 0x06
    #define DCH_INT_CHSDIF                 0x07
    #define DCH_INT_CHERIE                 0x10
    #define DCH_INT_CHTAIE                 0x11
    #define DCH_INT_CHCCIE                 0x12
    #define DCH_INT_CHBCIE                 0x13
    #define DCH_INT_CHDHIE                 0x14
    #define DCH_INT_CHDDIE                 0x15
    #define DCH_INT_CHSHIE                 0x16
    #define DCH_INT_CHSDIE                 0x17
#endif /* _JZ_P32MX_DMAC_H_ */
