#ifndef _JZ_PIC32MX_PORT_H_
#define _JZ_PIC32MX_PORT_H_
#include <stdint.h>


#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_1;
  #define _port_base_addr        (_sfrs_base_addr_1 + 0x6000)
#else
  #define _port_base_addr	((const void *)0xBF886000)
#endif


#if defined(__32MX1XX__) || defined(__32MX2XX__)
  #define PORTA		0
  #define PORTB		1
  #define PORTC		2
#elif defined(__32MX3XX__) || defined(__32MX4XX__)
  #define PORTA		0
  #define PORTB		1
  #define PORTC		2
  #define PORTD		3
  #define PORTE		4
  #define PORTF		5
  #define PORTG		6
#elif defined(__32MX5XX__) || defined(__32MX6XX__) || defined(__32MX7XX__)
  #define PORTA		0
  #define PORTB		1
  #define PORTC		2
  #define PORTD		3
  #define PORTE		4
  #define PORTF		5
  #define PORTG		6
#endif

#if defined(__32MX1XX__) || defined(__32MX2XX__)

  #define _PORT_ADDR(x)	(_port_base_addr + (x)*0x100)

  /* x=0:PORTA , x=1:PORTB , x=2:PORTC */
  #define ANSEL(x)           (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x00))
  #define ANSEL_CLR(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x04))
  #define ANSEL_SET(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x08))
  #define ANSEL_INV(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x0C))

  #define TRIS(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x10))
  #define TRIS_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x14))
  #define TRIS_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x18))
  #define TRIS_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x1C))

  #define PORT(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x20))
  #define PORT_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x24))
  #define PORT_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x28))
  #define PORT_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x2C))

  #define LAT(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x30))
  #define LAT_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x34))
  #define LAT_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x38))
  #define LAT_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x3C))

  #define ODC(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x40))
  #define ODC_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x44))
  #define ODC_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x48))
  #define ODC_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x4C))

  #define CNPU(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x50))
  #define CNPU_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x54))
  #define CNPU_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x58))
  #define CNPU_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x5C))

  #define CNPD(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x60))
  #define CNPD_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x64))
  #define CNPD_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x68))
  #define CNPD_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x6C))

  #define CNCON(x)           (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x70))
  #define CNCON_CLR(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x74))
  #define CNCON_SET(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x78))
  #define CNCON_INV(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x7C))

  #define CNEN(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x80))
  #define CNEN_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x84))
  #define CNEN_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x88))
  #define CNEN_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x8C))

  #define CNSTAT(x)          (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x90))
  #define CNSTAT_CLR(x)      (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x94))
  #define CNSTAT_SET(x)      (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x98))
  #define CNSTAT_INV(x)      (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x9C))

    #define CNCONx_SIDL     0x0D
    #define CNCONx_ON       0x0F

#else // elif defined(__32MX3XX__) || defined(__32MX4XX__)

  #define _PORT_ADDR(x)	(_port_base_addr + (x)*0x40)

  #define TRIS(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x00))
  #define TRIS_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x04))
  #define TRIS_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x08))
  #define TRIS_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x0C))

  #define PORT(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x10))
  #define PORT_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x14))
  #define PORT_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x18))
  #define PORT_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x1C))

  #define LAT(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x20))
  #define LAT_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x24))
  #define LAT_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x28))
  #define LAT_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x2C))

  #define ODC(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x30))
  #define ODC_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x34))
  #define ODC_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x38))
  #define ODC_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x3C))
#endif

#define port_clr(...) regx_clr(__VA_ARGS__)
#define port_set(...) regx_set(__VA_ARGS__)
#define port_inv(...) regx_inv(__VA_ARGS__)
#define port_is_clr(...) regx_is_clr(__VA_ARGS__)
#define port_is_set(...) regx_is_set(__VA_ARGS__)

#define PA0     PORTA,0
#define PA1     PORTA,1
#define PA2     PORTA,2
#define PA3     PORTA,3
#define PA4     PORTA,4
#define PA5     PORTA,5
#define PA6     PORTA,6
#define PA7     PORTA,7
#define PA8     PORTA,8
#define PA9     PORTA,9
#define PA10    PORTA,10
#define PA11    PORTA,11
#define PA12    PORTA,12
#define PA13    PORTA,13
#define PA14    PORTA,14
#define PA15    PORTA,15

#define PB0     PORTB,0
#define PB1     PORTB,1
#define PB2     PORTB,2
#define PB3     PORTB,3
#define PB4     PORTB,4
#define PB5     PORTB,5
#define PB6     PORTB,6
#define PB7     PORTB,7
#define PB8     PORTB,8
#define PB9     PORTB,9
#define PB10    PORTB,10
#define PB11    PORTB,11
#define PB12    PORTB,12
#define PB13    PORTB,13
#define PB14    PORTB,14
#define PB15    PORTB,15

#define PC0     PORTC,0
#define PC1     PORTC,1
#define PC2     PORTC,2
#define PC3     PORTC,3
#define PC4     PORTC,4
#define PC5     PORTC,5
#define PC6     PORTC,6
#define PC7     PORTC,7
#define PC8     PORTC,8
#define PC9     PORTC,9
#define PC10    PORTC,10
#define PC11    PORTC,11
#define PC12    PORTC,12
#define PC13    PORTC,13
#define PC14    PORTC,14
#define PC15    PORTC,15

#define PD0     PORTD,0
#define PD1     PORTD,1
#define PD2     PORTD,2
#define PD3     PORTD,3
#define PD4     PORTD,4
#define PD5     PORTD,5
#define PD6     PORTD,6
#define PD7     PORTD,7
#define PD8     PORTD,8
#define PD9     PORTD,9
#define PD10    PORTD,10
#define PD11    PORTD,11
#define PD12    PORTD,12
#define PD13    PORTD,13
#define PD14    PORTD,14
#define PD15    PORTD,15

#define PE0     PORTE,0
#define PE1     PORTE,1
#define PE2     PORTE,2
#define PE3     PORTE,3
#define PE4     PORTE,4
#define PE5     PORTE,5
#define PE6     PORTE,6
#define PE7     PORTE,7
#define PE8     PORTE,8
#define PE9     PORTE,9
#define PE10    PORTE,10
#define PE11    PORTE,11
#define PE12    PORTE,12
#define PE13    PORTE,13
#define PE14    PORTE,14
#define PE15    PORTE,15

#define PF0     PORTF,0
#define PF1     PORTF,1
#define PF2     PORTF,2
#define PF3     PORTF,3
#define PF4     PORTF,4
#define PF5     PORTF,5
#define PF6     PORTF,6
#define PF7     PORTF,7
#define PF8     PORTF,8
#define PF9     PORTF,9
#define PF10    PORTF,10
#define PF11    PORTF,11
#define PF12    PORTF,12
#define PF13    PORTF,13
#define PF14    PORTF,14
#define PF15    PORTF,15

#define PG0     PORTG,0
#define PG1     PORTG,1
#define PG2     PORTG,2
#define PG3     PORTG,3
#define PG4     PORTG,4
#define PG5     PORTG,5
#define PG6     PORTG,6
#define PG7     PORTG,7
#define PG8     PORTG,8
#define PG9     PORTG,9
#define PG10    PORTG,10
#define PG11    PORTG,11
#define PG12    PORTG,12
#define PG13    PORTG,13
#define PG14    PORTG,14
#define PG15    PORTG,15

#endif /* _JZ_PIC32MX_PORT_H_ */
