#ifndef _JZ_P32MX_USBOTG_H_
#define _JZ_P32MX_USBOTG_H_
#include <stdint.h>

#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_1;
  #define _usbotg_base_addr        (_sfrs_base_addr_1 + 0x5000)
#else
  #define _usbotg_base_addr	((const void *)0xBF885000)
#endif

#define _USBOTG_ADDR		(_usbotg_base_addr)
#define _USBOTG_EP_ADDR(x)	(_usbotg_base_addr + 0x300 + (x)*0x10)

  #define U_OTGIR          (*(volatile uint8_t *)(_USBOTG_ADDR + 0x40))
  #define U_OTGIR_CLR      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x44))
  #define U_OTGIE          (*(volatile uint8_t *)(_USBOTG_ADDR + 0x50))
  #define U_OTGIE_CLR      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x54))
  #define U_OTGIE_SET      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x58))
  #define U_OTGIE_INV      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x5C))
  #define U_OTGSTAT        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x60))
  #define U_OTGCON         (*(volatile uint8_t *)(_USBOTG_ADDR + 0x70))
  #define U_OTGCON_CLR     (*(volatile uint8_t *)(_USBOTG_ADDR + 0x74))
  #define U_OTGCON_SET     (*(volatile uint8_t *)(_USBOTG_ADDR + 0x78))
  #define U_OTGCON_INV     (*(volatile uint8_t *)(_USBOTG_ADDR + 0x7C))
  #define U_PWRC           (*(volatile uint8_t *)(_USBOTG_ADDR + 0x80))
  #define U_PWRC_CLR       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x84))
  #define U_PWRC_SET       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x88))
  #define U_PWRC_INV       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x8C))
  #define U_IR             (*(volatile uint8_t *)(_USBOTG_ADDR + 0x200))
  #define U_IR_CLR         (*(volatile uint8_t *)(_USBOTG_ADDR + 0x204))
  #define U_IE             (*(volatile uint8_t *)(_USBOTG_ADDR + 0x210))
  #define U_IE_CLR         (*(volatile uint8_t *)(_USBOTG_ADDR + 0x214))
  #define U_IE_SET         (*(volatile uint8_t *)(_USBOTG_ADDR + 0x218))
  #define U_IE_INV         (*(volatile uint8_t *)(_USBOTG_ADDR + 0x21C))
  #define U_EIR            (*(volatile uint8_t *)(_USBOTG_ADDR + 0x220))
  #define U_EIR_CLR        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x224))
  #define U_EIE            (*(volatile uint8_t *)(_USBOTG_ADDR + 0x230))
  #define U_EIE_CLR        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x234))
  #define U_EIE_SET        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x238))
  #define U_EIE_INV        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x23C))
  #define U_STAT           (*(volatile uint8_t *)(_USBOTG_ADDR + 0x240))
  #define U_STAT_CLR       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x244))
  #define U_STAT_SET       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x248))
  #define U_STAT_INV       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x24C))
  #define U_CON            (*(volatile uint8_t *)(_USBOTG_ADDR + 0x250))
  #define U_CON_CLR        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x254))
  #define U_CON_SET        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x258))
  #define U_CON_INV        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x25C))
  #define U_ADDR           (*(volatile uint8_t *)(_USBOTG_ADDR + 0x260))
  #define U_ADDR_CLR       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x264))
  #define U_ADDR_SET       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x268))
  #define U_ADDR_INV       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x26C))
  #define U_BDTP1          (*(volatile uint8_t *)(_USBOTG_ADDR + 0x270))
  #define U_BDTP1_CLR      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x274))
  #define U_BDTP1_SET      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x278))
  #define U_BDTP1_INV      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x27C))
  #define U_FRML           (*(volatile uint8_t *)(_USBOTG_ADDR + 0x280))
  #define U_FRMLCLR        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x284))
  #define U_FRMLSET        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x288))
  #define U_FRMLINV        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x28C))
  #define U_FRMH           (*(volatile uint8_t *)(_USBOTG_ADDR + 0x290))
  #define U_FRMH_CLR       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x294))
  #define U_FRMH_SET       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x298))
  #define U_FRMH_INV       (*(volatile uint8_t *)(_USBOTG_ADDR + 0x29C))
  #define U_TOK            (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2A0))
  #define U_TOK_CLR        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2A4))
  #define U_TOK_SET        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2A8))
  #define U_TOK_INV        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2AC))
  #define U_SOF            (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2B0))
  #define U_SOF_CLR        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2B4))
  #define U_SOF_SET        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2B8))
  #define U_SOF_INV        (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2BC))
  #define U_BDTP2          (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2C0))
  #define U_BDTP2_CLR      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2C4))
  #define U_BDTP2_SET      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2C8))
  #define U_BDTP2_INV      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2CC))
  #define U_BDTP3          (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2D0))
  #define U_BDTP3_CLR      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2D4))
  #define U_BDTP3_SET      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2D8))
  #define U_BDTP3_INV      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2DC))
  #define U_CNFG1          (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2E0))
  #define U_CNFG1_CLR      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2E4))
  #define U_CNFG1_SET      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2E8))
  #define U_CNFG1_INV      (*(volatile uint8_t *)(_USBOTG_ADDR + 0x2EC))

  /* x=1: EP0 ... x=15: EP15 */
  #define U_EP(x)          (*(volatile uint8_t *)(_USBOTG_EP_ADDR(x) + 0x0))
  #define U_EP0_CLR(x)     (*(volatile uint8_t *)(_USBOTG_EP_ADDR(x) + 0x4))
  #define U_EP0_SET(x)     (*(volatile uint8_t *)(_USBOTG_EP_ADDR(x) + 0x8))
  #define U_EP0_INV(x)     (*(volatile uint8_t *)(_USBOTG_EP_ADDR(x) + 0xC))

    #define U_OTGI_VBUSVD               0x00
    #define U_OTGI_SESEND               0x02
    #define U_OTGI_SESVD                0x03
    #define U_OTGI_ACTV                 0x04
    #define U_OTGI_LSTATE               0x05
    #define U_OTGI_T1MSEC               0x06
    #define U_OTGI_ID                   0x07

    #define U_OTGSTAT_VBUSVD               0x00
    #define U_OTGSTAT_SESEND               0x02
    #define U_OTGSTAT_SESVD                0x03
    #define U_OTGSTAT_LSTATE               0x05
    #define U_OTGSTAT_ID                   0x07
    #define U_OTGCON_VBUSDIS               0x00
    #define U_OTGCON_VBUSCHG               0x01
    #define U_OTGCON_OTGEN                 0x02
    #define U_OTGCON_VBUSON                0x03
    #define U_OTGCON_DMPULDWN              0x04
    #define U_OTGCON_DPPULDWN              0x05
    #define U_OTGCON_DMPULUP               0x06
    #define U_OTGCON_DPPULUP               0x07

    #define U_PWRC_USBPWR                  0x00
    #define U_PWRC_USUSPEND                0x01
    #define U_PWRC_USBBUSY                 0x03
    #define U_PWRC_USLPGRD                 0x04
    #define U_PWRC_UACTPND                 0x07

    #define U_I_URST_DETACH             0x00
    #define U_I_DETACH                  0x00
    #define U_I_URST                    0x00
    #define U_I_UERR                    0x01
    #define U_I_SOF                     0x02
    #define U_I_TRN                     0x03
    #define U_I_IDLE                    0x04
    #define U_I_RESUME                  0x05
    #define U_I_ATTACH                  0x06
    #define U_I_STALL                   0x07

    #define U_EI_PID                    0x00
    #define U_EI_CRC5_EOF               0x01
    #define U_EI_CRC5                   0x01
    #define U_EI_EOF                    0x01
    #define U_EI_CRC16                  0x02
    #define U_EI_DFN8                   0x03
    #define U_EI_BTO                    0x04
    #define U_EI_DMA                    0x05
    #define U_EI_BMX                    0x06
    #define U_EI_BTS                    0x07

    #define U_STAT_PPBI                    0x02
    #define U_STAT_DIR                     0x03
    #define U_STAT_ENDPT                   0x04

    #define U_CON_USBEN_SOFEN              0x00
    #define U_CON_USBEN                    0x00
    #define U_CON_SOFEN                    0x00
    #define U_CON_PPBRST                   0x01
    #define U_CON_RESUME                   0x02
    #define U_CON_HOSTEN                   0x03
    #define U_CON_USBRST                   0x04
    #define U_CON_PKTDIS_TOKBUSY           0x05
    #define U_CON_PKTDIS                   0x05
    #define U_CON_TOKBUSY                  0x05
    #define U_CON_SE0                      0x06
    #define U_CON_JSTATE                   0x07

    #define U_ADDR_LSPDEN                  0x07
    #define U_ADDR_DEVADDR                 0x00
    #define U_FRML_FRML                    0x00
    #define U_FRML_FRM0                    0x00
    #define U_FRML_FRM1                    0x01
    #define U_FRML_FRM2                    0x02
    #define U_FRML_FRM3                    0x03
    #define U_FRML_FRM4                    0x04
    #define U_FRML_FRM5                    0x05
    #define U_FRML_FRM6                    0x06
    #define U_FRML_FRM7                    0x07
    #define U_FRMH_FRMH                    0x00
    #define U_FRMH_FRM8                    0x00
    #define U_FRMH_FRM9                    0x01
    #define U_FRMH_FRM10                   0x02

    #define U_TOK_EP                       0x00
    #define U_TOK_PID                      0x04
    #define U_TOK_EP0                      0x00
    #define U_TOK_EP1                      0x01
    #define U_TOK_EP2                      0x02
    #define U_TOK_EP3                      0x03
    #define U_TOK_PID0                     0x04
    #define U_TOK_PID1                     0x05
    #define U_TOK_PID2                     0x06
    #define U_TOK_PID3                     0x07

    #define U_SOF_CNT                      0x00
    #define U_CNFG1_UASUSPND               0x00
    #define U_CNFG1_USBSIDL                0x04
    #define U_CNFG1_UOEMON                 0x06
    #define U_CNFG1_UTEYE                  0x07

    #define U_EP_EPHSHK                   0x00
    #define U_EP_EPSTALL                  0x01
    #define U_EP_EPTXEN                   0x02
    #define U_EP_EPRXEN                   0x03
    #define U_EP_EPCONDIS                 0x04
    #define U_EP_EPTRYDIS                 0x06
    #define U_EP_LSPD                     0x07


struct _usbotg_buffer_desc
{
	volatile uint8_t ctl;
	volatile uint8_t rfu;
	volatile uint16_t len;
	uint8_t *buf;
};
#define U_BD_PID	0x02

#define U_BD_BSTALL	0x02
#define U_BD_DTS	0x03
#define U_BD_NINC	0x04
#define U_BD_KEEP	0x05

#define U_BD_DATA01	0x06
#define U_BD_UOWN	0x07

#define BDT_SECTION __attribute__((section(".bdt")))

struct _usbotg_bdt 
{
	struct _usbotg_buffer_desc rx[2];
	struct _usbotg_buffer_desc tx[2];
};
// extern struct _usbotg_bdt _usbotg_bdt[16] BDT_SECTION;

#endif /* _JZ_P32MX_USBOTG_H_ */
