#ifndef _JZ_WDT_H_
#define _JZ_WDT_H_
#include <p32mx/p32mx_wdt.h>

/* avr-libc style wdt handling */

#define	WDTO_15MS	  123
#define	WDTO_30MS	  246
#define	WDTO_60MS	  492
#define	WDTO_120MS	  983
#define	WDTO_250MS	 2048
#define	WDTO_500MS	 4096
#define	WDTO_1S		 8192	/* = 32768/4 */
#define	WDTO_2S		16384
#define	WDTO_4S		32768
#define	WDTO_8S		0xffff

#define	WDTO_16S	( 8192<<4)
#define	WDTO_32S	(16384<<4)
#define	WDTO_64S	(32768<<4)
#define	WDTO_128S	(0xffff<<4)
    #define WDTCON_WDTCLR                  0x00
    #define WDTCON_WDTWINEN                0x01
    #define WDTCON_SWDTPS                  0x02
    #define WDTCON_ON                      0x0F

#define wdt_reset() 	 	{ WDTCONb_SET = (1 << WDTCON_WDTCLR ); }
#define wdt_enable()		{ WDTCON_SET = (1 << WDTCON_ON ); }
#define wdt_disable()		{ WDTCON_CLR = (1 << WDTCON_ON ); }

#endif /* _JZ_WDT_H_ */
